;------------------------------------------------------------------------------
;
; Definition of the system's CONFIGURATION
;
;------------------------------------------------------------------------------

(define compile-primitives #f)

; *** temporary definitions ***
(define (make-delayed) 1)
(define (write*) 1)
(define (error) 1)
(define (procedure-info) 1)
(define (char-uppercase) 1)

(define (primitive-procedure name)
  (let ((x (assq name *primitive-procedures*)))
    (if x
      (second x)
      #f)))

(define (primitive-procedure->name proc)
  (define (find proc l)
    (cond ((null? l)                     #f)
          ((eq? proc (second (first l))) (first (first l)))
          (else                          (find proc (after-first l)))))
  (find proc *primitive-procedures*))

(define (primitive-entry-point name nb-args)
  (let ((x (assq name *primitive-procedures*)))
    (if x
      (= (remainder (quotient (third x) (expt 2 nb-args)) 2) 1)
      #f)))

;------------------------------------------------------------------------------
