;------------------------------------------------------------------------------
;
; QUEUE manipulation package
;
;------------------------------------------------------------------------------

(define (list->queue list)    ; convert list to queue
  (cons list (if (null? list) '() (last-pair list))))

(define (queue->list queue)   ; convert queue to list
  (car queue))

(define (queue-empty)         ; the empty set
  (cons '() '()))

(define (queue-length queue)  ; return the length of the queue
  (length (car queue)))

(define (queue-empty? queue)  ; is the queue empty?
  (null? (car queue)))

(define (queue-get! queue)    ; remove the first element of the queue
  (if (null? (car queue))
    (error "Can not remove an element from an empty queue")
    (let ((x (caar queue)))
      (set-car! queue (cdar queue))
      (if (null? (car queue)) (set-cdr! queue '()))
      x)))

(define (queue-put! queue x)  ; add an element to the end of the queue
  (let ((entry (cons x '())))
    (if (null? (car queue))
      (set-car! queue entry)
      (set-cdr! (cdr queue) entry))
    (set-cdr! queue entry)
    x))

;------------------------------------------------------------------------------
