cst_nil		= 0xFFFFFFFF	| -1
cst_false	= 0xFFFFFFFD	| -3
cst_true	= 0xFFFFFFFB	| -5
cst_undefined	= 0xFFFFFFF9	| -7
forwarded_pair	= 0xFFFFFFF7	| -9, if car of pair is this value, pair has
				|   already been forwarded to new space

vector_type	= 0x00		| type field for vectors
symbol_type	= 0x01		| type field for symbols
string_type	= 0x30		| type field for strings
stack_type	= 0x20		| type field for stacks

|------------------------------------------------------------------------------
|
| Macro definitions:
|

define(concatenate,`$1$2$3$4$5$6$7$8$9')
define(the_number,`0')
define(new_number,`define(`the_number',incr(the_number))the_number')
define(new_symbol,`define(`the_symbol',concatenate($1,new_number))the_symbol')

define(change_area,
`define(`current_area',$1)
	$1')

define(begin_main,
`	.lcomm	_reg_at_entry,4*16
	change_area(.text)
	.globl	_entry
_entry:
	moveml	d0-d7/a0-a7,_reg_at_entry
	movl	sp,d0
	andl	#0xfffffffc,d0
	movl	d0,sp')

define(end_main,
`	moveml	_reg_at_entry,d0-d7/a0-a7
	rts')

define(save_regs,
`	moveml	d0-d7/a0-a6,sp@-')

define(restore_regs,
`	moveml	sp@+,d0-d7/a0-a6')

define(print_str,
`	.data2
new_symbol(Str):	.asciz	$1
	current_area
save_regs
	pea	the_symbol
	jbsr	_printf
	addqw	#0x4,sp
restore_regs')

define(print_int,
`	.data2
new_symbol(Str):	.asciz	$1
	current_area
save_regs
	movl	$2,sp@-
	pea	the_symbol
	jbsr	_printf
	addqw	#0x8,sp
restore_regs')

define(print_chr,
`	.data2
new_symbol(Str):	.asciz	$1
	current_area
save_regs
	movb	$2,d0
	extbl	d0
	movl	d0,sp@-
	pea	the_symbol
	jbsr	_printf
	addqw	#0x8,sp
restore_regs')

| -----------------------------------------------------------------------------
|
| This file contains the library routines for the Scheme system.
|
| -----------------------------------------------------------------------------

| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
|
| Some M4 definitions:
|

define(EXPORT,`DEF.$1 = $1')

| Scheme constants:

null	= -1	| constant ()
false	= -3	| constant #f
true	= -5	| constant #t

EXPORT(null)
EXPORT(false)
EXPORT(true)

| Register assignments:

define(DREG,`$1 = d$2
$1_reg = $2')
define(AREG,`$1 = a$2
$1_reg = $2+8')

nb_args_in_regs	= 3	| number of arguments that are passed in registers
nb_adr		= 3	| number of temporary address registers

DREG(arg_count,0)	| d0 contains the nb of arguments passed (16 bits)
DREG(first_arg,1)	| d1 contains the first argument
DREG(free_count,4)	| d4 contains the free space count (in quad-bytes)
DREG(fix_mask,5)	| d5 contains the fixnum type mask (i.e. 0x01010101)
DREG(pair_mask,6)	| d6 contains the pair type mask (i.e. 0x10101010)
DREG(hunk_mask,7)	| d7 contains the hunk type mask (i.e. 0x44444444)

AREG(return_adr,0)	| a0 contains the return address of the procedure
AREG(first_adr,1)	| a1 is the first temporary address register
AREG(pair_alloc,3)	| a3 is the pair allocation pointer
AREG(hunk_alloc,4)	| a4 is the hunk allocation pointer
AREG(runtime_ptr,5)	| a5 points to the runtime procedures & handlers
AREG(global_ptr,6)	| a6 points to the globals (global vars and const)
AREG(stack_ptr,7)	| a7 is the stack pointer

define(ARG,``d'$1')
define(ADR,``a'$1')

| -----------------------------------------------------------------------------
|
| Interface for SUN:
|


	.globl	_main
_main:
	link	a6,#0
	jbsr	_entry
	unlk	a6
	rts

begin_main

	lea	heap,a0	| make sure pairs are on octuple address

	movl	a0,d0
	andl	#7,d0
	beq	hunks_are_ok
print_str("Can not execute; heap is not at an address multiple of 8\012")
	bra	exit

hunks_are_ok:
	lea	pair_end,a0	| make sure pairs are on octuple address

	movl	a0,d0
	andl	#7,d0
	beq	pairs_are_ok
print_str("Can not execute; pairs are not at an address multiple of 8\012")
	jmp	exit

pairs_are_ok:

	jmp	test

exit:

end_main

	change_area(.data)
