	AREA(.text)

|------------------------------------------------------------------------------

	.globl	trap_handler
trap_handler:

	movl	sp@+,ADR(1)	| get return address

	lea	global_ptr@(-0x8000),ADR(2)
	cmpl	ADR(2),ADR(1)
	bcss	parameterized_trap
	lea	global_ptr@(0x7fff),ADR(2)
	cmpl	ADR(2),ADR(1)
	bccs	parameterized_trap

| global jump trap

	movw	arg_count,sp@-	| save argument count temporarily
	movl	ADR(1)@,arg_count
	IF_NOT_PROC(ARG(0),ADR(2),global_not_proc)
	movw	#jump_opcode,ADR(1)@(-2) | replace trap opcode by a jump opcode
	movw	sp@+,arg_count	| restore argument count and set flags
	jmp	ADR(2)@		| jump to procedure

global_not_proc:

| ...

parameterized_trap:

	movl	ARG(1),sp@-	| save argument register 1
	movw	ADR(1)@+,ARG(1)	| get trap parameter

trap_a:

	cmpb	#cons_trap,ARG(1) | what kind of trap was it?
	bnes	trap_b

| ...

trap_b:

|------------------------------------------------------------------------------

	.globl	_scheme_restart
_scheme_restart:

	movl	sp@(4),ARG(1)		| get argument

	movl	_glob_ptr,a0
	moveml	a6/a7,a0@(_system_fp)	| save system's context
	movl	a0,global_ptr

	moveml	GLOBAL(fix_mask),fix_mask/pair_mask/hunk_mask/free_count/pair_alloc/hunk_alloc/lib_ptr/sp

	moveq	#-1,arg_count		| 1 argument
	rts				| jump to continuation point

|------------------------------------------------------------------------------

c_restart:

	moveml	free_count/pair_alloc/hunk_alloc,GLOBAL(free_count)

	moveml	GLOBAL(system_fp),a6/a7	| restore system's context

	movl	ARG(1),d0		| return argument 1

	rts				| restart C code

|------------------------------------------------------------------------------

c_jump:

	moveml	free_count/pair_alloc/hunk_alloc,GLOBAL(free_count)
	movl	sp,GLOBAL(sis_sp)
	moveml	GLOBAL(system_fp),a6/a7	| restore system's context

	movl	ARG(3),sp@-		| push argument 3
	movl	ARG(2),sp@-		| push argument 2
	movl	ARG(1),sp@-		| push argument 1

	jsr	ADR(0)@			| call C routine

	movl	d0,ARG(1)		| get returned value

	movl	_glob_ptr,global_ptr

	moveml	GLOBAL(fix_mask),fix_mask/pair_mask/hunk_mask/free_count/pair_alloc/hunk_alloc/lib_ptr/sp

	moveq	#-1,arg_count		| 1 argument
	rts				| jump to continuation point

|------------------------------------------------------------------------------

	.globl	_sis_entry
_sis_entry:
	
	movl	ARG(1),ARG(2)
	movl	#msg1,ARG(1)
	C_CALL(printf)

	movl	#msg2,ARG(1)
	movl	#7*8,ARG(2)
	movl	#13*8,ARG(3)
	C_CALL(printf)

	movl	#msg3,ARG(1)
	movl	#msg4,ARG(2)
	movl	#msg4,ARG(3)
	C_CALL(printf)

	movl	#8,ARG(1)
	bra	c_restart

msg1:	.asciz	"msg1(%d)\012"
msg2:	.asciz	"msg2%d,%d\012"
msg3:	.asciz	"msg3(%s,%s)\012"
msg4:	.asciz	"msg4"

