|------------------------------------------------------------------------------

	.data1
	.align	4
|	.skip	0
	.globl	_pair_area1
_pair_area1:

|------------------------------------------------------------------------------

	AREA(data2)

	.align	2
	.globl	_library_table
_library_table:

	movl	stack_ptr@+,a1	| get return address

	lea	glob_ptr@(-0x8000),a2
	cmpl	a2,a1
	bcss	parameterized_trap
	lea	glob_ptr@(0x7fff),a2
	cmpl	a2,a1
	bccs	parameterized_trap

| global jump trap

	movw	arg_count,stack_ptr@-	| save argument count temporarily
	movl	a1@,arg_count
	btst	arg_count,hunk_mask
	beqs	global_not_proc
	movl	arg_count,a2
	tstw	a2@(-2)
	bpls	global_not_proc

	movw	#jump_opcode,a1@(-2)	| replace trap opcode by a jump opcode
	movw	stack_ptr@+,arg_count	| restore argument count and set flags
	jmp	a2@			| jump to procedure

global_not_proc:

	pea	msg0
	jbsr	_fatal:l
msg0:	.asciz	"trying to call a non-procedure bound to a global var"

	.align	2

parameterized_trap:

	movl	d1,stack_ptr@-	| save argument register 1
	movw	a1@+,d1		| get trap parameter

	movl	d1,d2
	lsrw	#2,d2
	andl	#0x3ffc,d2
	movl	a1,d3
	subl	d2,d3
	subql	#2,d3
	bset	#1,d3
	movl	d3,a2

	movw	a2@(-2),d0
	andw	#0x1fff,d0
	aslw	#2,d0

	moveml	d1-d7/a0/a4-a6,sp@-
	pea	a2@(2,d0:w)
	jbsr	_warning:l
	moveml	sp@+,d1-d7/a0/a4-a6

	andb	#0xf,d1
	cmpb	#0,d1
	bnes	l1
	pea	trap0
	bra	write_trap
l1:
	cmpb	#1,d1
	bnes	l2
	pea	trap1
	bra	write_trap
l2:
	cmpb	#2,d1
	bnes	l3
	pea	trap2
	bra	write_trap
l3:
	cmpb	#3,d1
	bnes	l4
	pea	trap3
	bra	write_trap
l4:
	cmpb	#4,d1
	bnes	l5
	pea	trap4
	bra	write_trap
l5:
	cmpb	#5,d1
	bnes	l6
	pea	trap5
	bra	write_trap
l6:
	cmpb	#6,d1
	bnes	l7
	pea	trap6
	bra	write_trap
l7:
	cmpb	#7,d1
	bnes	l8
	pea	trap7
	bra	write_trap
l8:
	cmpb	#8,d1
	bnes	l9
	pea	trap8
	bra	write_trap
l9:
	cmpb	#9,d1
	bnes	l10
	pea	trap9
	bra	write_trap
l10:
	cmpb	#10,d1
	bnes	l11
	pea	trap10
	bra	write_trap
l11:
	cmpb	#11,d1
	bnes	l12
	pea	trap11
	bra	write_trap
l12:
	pea	msg1
write_trap:
	jbsr	_fatal:l
trap0:	.asciz	"trap 0, check_stack_trap"
trap1:	.asciz	"trap 1, non_proc_trap"
trap2:	.asciz	"trap 2, arity_trap"
trap3:	.asciz	"trap 3, clo_arity_trap"
trap4:	.asciz	"trap 4, wrong_type_trap"
trap5:	.asciz	"trap 5, arith_ovfl_trap"
trap6:	.asciz	"trap 6, out_bound_trap"
trap7:	.asciz	"trap 7"
trap8:	.asciz	"trap 8"
trap9:	.asciz	"trap 9, not_impl_trap"
trap10:	.asciz	"trap 10, cons_trap"
trap11:	.asciz	"trap 11, heap_trap"

msg1:	.asciz	"parameterized trap handler called"

|------------------------------------------------------------------------------

	.align	4

	.globl _fix_mask
	.globl _pair_mask
	.globl _hunk_mask
	.globl _empty_list
	.globl _libr_ptr
	.globl _glob_ptr

	.globl _heap_ptr
	.globl _sub_heap_ptr
	.globl _sub_heap_size
	.globl _heap_alloc_ptr
	.globl _free_count

	.globl _current_process

_fix_mask:	.long	0
_pair_mask:	.long	0
_hunk_mask:	.long	0
_empty_list:	.long	0
_libr_ptr:	.long	0
_glob_ptr:	.long	0

_heap_ptr:	.long	0
_sub_heap_ptr:	.long	0
_sub_heap_size:	.long	0
_heap_alloc_ptr:.long	0
_free_count:	.long	0

_current_process:.long	0

heap_alloc_ptr	= _heap_alloc_ptr-_library_table
free_count	= _free_count-_library_table
current_process	= _current_process-_library_table

|------------------------------------------------------------------------------

	.align	2
	.globl	make_closures
make_closures:

	subl	d0,libr_ptr@(free_count:w)
	bmis	make_closures1

	movl	libr_ptr@(heap_alloc_ptr:w),a2
	asll	#2,d0
	addl	d0,libr_ptr@(heap_alloc_ptr:w)

	jmp	a1@

make_closures1:
	.word	trap_opcode
	.word	heap_trap

	.align	2
	.globl	make_cell
make_cell:

	movl	libr_ptr@(heap_alloc_ptr:w),d0
	btst	d0,pair_mask	| address is a multiple of 8?
	beqs	make_cell1	| yes
	addql	#4,d0
	movl	d0,libr_ptr@(heap_alloc_ptr:w)
	subql	#1,libr_ptr@(free_count:w)
make_cell1:
	movl	d0,a3
	movl	empty_list,a3@+
	movl	a2,a3@

	addql	#8,libr_ptr@(heap_alloc_ptr:w)
	subql	#2,libr_ptr@(free_count:w)

	bmis	make_cell2

	jmp	a1@

make_cell2:
	.word	trap_opcode
	.word	heap_trap

	.align	2
	.globl	enter_rest
enter_rest:

	movl	stack_ptr@+,a1	| get return address

	bpls	enter_rest1

	moveq	#1,d0		| 1 arg passed
	movl	d1,stack_ptr@-
	bras	enter_rest3

enter_rest1:
	bnes	enter_rest2

	moveq	#2,d0		| 2 args passed
	movl	d1,stack_ptr@-
	movl	d2,stack_ptr@-
	bras	enter_rest3

enter_rest2:
	subqw	#1,d0
	extl	d0
	beqs	enter_rest3

	movl	d1,stack_ptr@-
	movl	d2,stack_ptr@-
	movl	d3,stack_ptr@-

enter_rest3:
	subw	a1@,d0	| enough args?
	bcss	enter_rest_too_few

	movl	libr_ptr@(heap_alloc_ptr:w),d1
	btst	d1,pair_mask	| address is a multiple of 8?
	beqs	enter_rest4	| yes
	addql	#4,d1
	movl	d1,libr_ptr@(heap_alloc_ptr:w)
	subql	#1,libr_ptr@(free_count:w)
enter_rest4:
	asll	#1,d0
	subl	d0,libr_ptr@(free_count:w)
	bmis	enter_rest7

	asrl	#1,d0
	movl	d1,a2

	movl	empty_list,d1
	bras	enter_rest6

enter_rest5:
	movl	d1,a2@+
	movl	a2,d1
	movl	stack_ptr@+,a2@+
enter_rest6:
	dbra	d0,enter_rest5

	movl	a2,libr_ptr@(heap_alloc_ptr:w)

	jmp	a1@(2)

enter_rest7:
	.word	trap_opcode
	.word	cons_trap

enter_rest_too_few:
	pea	msg4
	jbsr	_fatal:l
msg4:	.asciz	"too few arguments passed to a procedure"

	.align	2
	.globl	enter_rest_clo
enter_rest_clo:

	movl	stack_ptr@+,a1	| get return address
	movl	stack_ptr@+,a3	| get closed var pointer
	subql	#6,a3

	bpls	enter_rest_clo1

	moveq	#1,d0		| 1 arg passed
	movl	d1,stack_ptr@-
	bras	enter_rest_clo3

enter_rest_clo1:
	bnes	enter_rest_clo2

	moveq	#2,d0		| 2 args passed
	movl	d1,stack_ptr@-
	movl	d2,stack_ptr@-
	bras	enter_rest_clo3

enter_rest_clo2:
	subqw	#1,d0
	extl	d0
	beqs	enter_rest_clo3

	movl	d1,stack_ptr@-
	movl	d2,stack_ptr@-
	movl	d3,stack_ptr@-

enter_rest_clo3:
	subw	a1@,d0	| enough args?
	bcss	enter_rest_clo_too_few

	movl	libr_ptr@(heap_alloc_ptr:w),d1
	btst	d1,pair_mask	| address is a multiple of 8?
	beqs	enter_rest_clo4	| yes
	addql	#4,d1
	movl	d1,libr_ptr@(heap_alloc_ptr:w)
	subql	#1,libr_ptr@(free_count:w)
enter_rest_clo4:
	asll	#1,d0
	subl	d0,libr_ptr@(free_count:w)
	bmis	enter_rest_clo7

	asrl	#1,d0
	movl	d1,a2

	movl	empty_list,d1
	bras	enter_rest_clo6

enter_rest_clo5:
	movl	d1,a2@+
	movl	a2,d1
	movl	stack_ptr@+,a2@+
enter_rest_clo6:
	dbra	d0,enter_rest_clo5

	movl	a2,libr_ptr@(heap_alloc_ptr:w)

	movl	a3,stack_ptr@-

	jmp	a1@(2)

enter_rest_clo7:
	.word	trap_opcode
	.word	cons_trap

enter_rest_clo_too_few:
	pea	msg5
	jbsr	_fatal:l
msg5:	.asciz	"too few arguments passed to a procedure"

	.align	2
	.globl	_sis_entry
_sis_entry:
	bra	SCM..

DEFINE_PRIMITIVE(`')
	moveml	d0-d7/a0-a6,stack_ptr@-

	COPY(imm(undefined),reg(1))
	COPY(reg(1),reg(2))
	COPY(reg(1),reg(3))
	COPY(reg(1),reg(0))

	moveml	_fix_mask,fix_mask/pair_mask/hunk_mask/empty_list/libr_ptr/glob_ptr

	movl	stack_ptr,a3
	movl	libr_ptr@(current_process:w),a1
	movl	a1@(6),a1 | get current stack
	subql	#2,a1
	movl	a1@+,d0
	lea	a1@(1024),a2
	movl	a2,a6@
	andl	#0xfffffc,d0
	addl	d0,a1
	movl	a1@-,d0
	asrl	#1,d0
	subl	d0,a1
	movl	a1,stack_ptr
	movl	a3,stack_ptr@-

	COPY(prim(```NOT'''),glob(2))
	COPY(prim(```BOOLEAN?'''),glob(3))
	COPY(prim(```EQV?'''),glob(4))
	COPY(prim(```EQ?'''),glob(5))
	COPY(prim(```EQUAL?'''),glob(6))
	COPY(prim(```PAIR?'''),glob(7))
	COPY(prim(```CONS'''),glob(8))
	COPY(prim(```CAR'''),glob(9))
	COPY(prim(```CDR'''),glob(10))
	COPY(prim(```SET-CAR!'''),glob(11))
	COPY(prim(```SET-CDR!'''),glob(12))
	COPY(prim(```CAAR'''),glob(13))
	COPY(prim(```CADR'''),glob(14))
	COPY(prim(```CDAR'''),glob(15))
	COPY(prim(```CDDR'''),glob(16))
	COPY(prim(```CAAAR'''),glob(17))
	COPY(prim(```CAADR'''),glob(18))
	COPY(prim(```CADAR'''),glob(19))
	COPY(prim(```CADDR'''),glob(20))
	COPY(prim(```CDAAR'''),glob(21))
	COPY(prim(```CDADR'''),glob(22))
	COPY(prim(```CDDAR'''),glob(23))
	COPY(prim(```CDDDR'''),glob(24))
	COPY(prim(```CAAAAR'''),glob(25))
	COPY(prim(```CAAADR'''),glob(26))
	COPY(prim(```CAADAR'''),glob(27))
	COPY(prim(```CAADDR'''),glob(28))
	COPY(prim(```CADAAR'''),glob(29))
	COPY(prim(```CADADR'''),glob(30))
	COPY(prim(```CADDAR'''),glob(31))
	COPY(prim(```CADDDR'''),glob(32))
	COPY(prim(```CDAAAR'''),glob(33))
	COPY(prim(```CDAADR'''),glob(34))
	COPY(prim(```CDADAR'''),glob(35))
	COPY(prim(```CDADDR'''),glob(36))
	COPY(prim(```CDDAAR'''),glob(37))
	COPY(prim(```CDDADR'''),glob(38))
	COPY(prim(```CDDDAR'''),glob(39))
	COPY(prim(```CDDDDR'''),glob(40))
	COPY(prim(```NULL?'''),glob(41))
	COPY(prim(```LIST'''),glob(42))
	COPY(prim(```LENGTH'''),glob(43))
	COPY(prim(```APPEND'''),glob(44))
	COPY(prim(```REVERSE'''),glob(45))
	COPY(prim(```LIST-TAIL'''),glob(46))
	COPY(prim(```LIST-REF'''),glob(47))
	COPY(prim(```LAST-PAIR'''),glob(48))
	COPY(prim(```MEMQ'''),glob(49))
	COPY(prim(```MEMV'''),glob(50))
	COPY(prim(```MEMBER'''),glob(51))
	COPY(prim(```ASSQ'''),glob(52))
	COPY(prim(```ASSV'''),glob(53))
	COPY(prim(```ASSOC'''),glob(54))
	COPY(prim(```SYMBOL?'''),glob(55))
	COPY(prim(```SYMBOL->STRING'''),glob(56))
	COPY(prim(```STRING->SYMBOL'''),glob(57))
	COPY(prim(```NUMBER?'''),glob(58))
	COPY(prim(```REAL?'''),glob(59))
	COPY(prim(```INTEGER?'''),glob(60))
	COPY(prim(```ODD?'''),glob(61))
	COPY(prim(```EVEN?'''),glob(62))
	COPY(prim(```='''),glob(63))
	COPY(prim(```<'''),glob(64))
	COPY(prim(```>'''),glob(65))
	COPY(prim(```<='''),glob(66))
	COPY(prim(```>='''),glob(67))
	COPY(prim(```MAX'''),glob(68))
	COPY(prim(```MIN'''),glob(69))
	COPY(prim(```+'''),glob(70))
	COPY(prim(```*'''),glob(71))
	COPY(prim(```-'''),glob(72))
	COPY(prim(```/'''),glob(73))
	COPY(prim(```ABS'''),glob(74))
	COPY(prim(```QUOTIENT'''),glob(75))
	COPY(prim(```REMAINDER'''),glob(76))
	COPY(prim(```EXPT'''),glob(77))
	COPY(prim(```NUMBER->STRING'''),glob(78))
	COPY(prim(```STRING->NUMBER'''),glob(79))
	COPY(prim(```CHAR?'''),glob(80))
	COPY(prim(```CHAR=?'''),glob(81))
	COPY(prim(```CHAR<?'''),glob(82))
	COPY(prim(```CHAR>?'''),glob(83))
	COPY(prim(```CHAR<=?'''),glob(84))
	COPY(prim(```CHAR>=?'''),glob(85))
	COPY(prim(```CHAR->INTEGER'''),glob(86))
	COPY(prim(```INTEGER->CHAR'''),glob(87))
	COPY(prim(```CHAR-UPPERCASE'''),glob(88))
	COPY(prim(```STRING?'''),glob(89))
	COPY(prim(```MAKE-STRING'''),glob(90))
	COPY(prim(```STRING-LENGTH'''),glob(91))
	COPY(prim(```STRING-REF'''),glob(92))
	COPY(prim(```STRING-SET!'''),glob(93))
	COPY(prim(```STRING=?'''),glob(94))
	COPY(prim(```STRING->LIST'''),glob(95))
	COPY(prim(```LIST->STRING'''),glob(96))
	COPY(prim(```VECTOR?'''),glob(97))
	COPY(prim(```MAKE-VECTOR'''),glob(98))
	COPY(prim(```VECTOR'''),glob(99))
	COPY(prim(```VECTOR-LENGTH'''),glob(100))
	COPY(prim(```VECTOR-REF'''),glob(101))
	COPY(prim(```VECTOR-SET!'''),glob(102))
	COPY(prim(```VECTOR->LIST'''),glob(103))
	COPY(prim(```LIST->VECTOR'''),glob(104))
	COPY(prim(```PROCEDURE?'''),glob(105))
	COPY(prim(```PROCEDURE-INFO'''),glob(106))
	COPY(prim(```APPLY'''),glob(107))
	COPY(prim(```MAP'''),glob(108))
	COPY(prim(```FOR-EACH'''),glob(109))
	COPY(prim(```MAKE-DELAYED'''),glob(110))
	COPY(prim(```FORCE'''),glob(111))
	COPY(prim(```CALL-WITH-CURRENT-CONTINUATION'''),glob(112))
	COPY(prim(```READ'''),glob(113))
	COPY(prim(```EOF-OBJECT?'''),glob(114))
	COPY(prim(```READ-CHAR'''),glob(115))
	COPY(prim(```PEEK-CHAR'''),glob(116))
	COPY(prim(```WRITE*'''),glob(117))
	COPY(prim(```WRITE'''),glob(118))
	COPY(prim(```DISPLAY'''),glob(119))
	COPY(prim(```NEWLINE'''),glob(120))
	COPY(prim(```WRITE-CHAR'''),glob(121))
	COPY(prim(```EXIT'''),glob(122))
	COPY(prim(```CURRENT-PROCESS'''),glob(123))
	COPY(prim(```CPU-TIME'''),glob(124))
	COPY(prim(```ERROR'''),glob(125))

	CALL(prim(```program-top-level'''),0)

	CALL(prim(```WRITE''',1),0)

	CALL(prim(```NEWLINE''',0),0)

	movl	stack_ptr@+,stack_ptr
	moveml	stack_ptr@+,d0-d7/a0-a6

	JUMP(pop,0)
END

DEFINE_PRIMITIVE(`process-transfer')
	.globl _process_transfer
_process_transfer:
	ENTER_CLO(1)
	COPY(pop,temp(1)) | get closure's address
	COPY(reg(0),push) | save continuation

	movl	libr_ptr@(current_process:w),a2
	movl	a2@(6),a2 | get current stack
	subql	#2,a2
	movl	a2@,d0
	andl	#0xfffffc,d0
	addl	d0,a2
	movl	a2,d0
	subl	stack_ptr,d0
	asll	#1,d0
	movl	d0,a2@

	movl	a1,libr_ptr@(current_process:w)
	movl	a1@(6),a1 | get new stack
	subql	#2,a1
	movl	a1@+,d0
	lea	a1@(1024),a2
	movl	a2,a6@
	andl	#0xfffffc,d0
	addl	d0,a1
	movl	a1@-,d0
	asrl	#1,d0
	subl	d0,a1
	movl	a1,stack_ptr
	JUMP(pop,0)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`CONS',2)					| CONS
	movl	libr_ptr@(heap_alloc_ptr:w),d0
	btst	d0,pair_mask	| address is a multiple of 8?
	beqs	LOCAL(1)	| yes
	addql	#4,d0
	movl	d0,libr_ptr@(heap_alloc_ptr:w)
	subql	#1,libr_ptr@(free_count:w)
LABEL(1)
	movl	d0,a1
	movl	d2,a1@+
	movl	d1,a1@
	movl	a1,d1

	addql	#8,libr_ptr@(heap_alloc_ptr:w)
	subql	#2,libr_ptr@(free_count:w)

	bmis	LOCAL(2)

	JUMP(reg(0),0)

LABEL(2)
	TRAP_CONS
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`SYMBOL->STRING',1)				| SYMBOL->STRING
	IF_NOT_SYMBOL(reg(1),1)
	COPY(indx(reg(1),2),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`STRING->SYMBOL',1)				| STRING->SYMBOL
	IF_NOT_STRING(reg(1),4)

	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(glob(1),push)
LABEL(1)
	IF_NOT_PAIR(stk(1),3)
	COPY(indx(indx(stk(1),0),2),reg(1))
	COPY(stk(2),reg(2))
	CALL(prim(```STRING=?''',2),0)
	IF(reg(1),2)
	COPY(indx(stk(1),-4),stk(1))
	JUMP(lbl(1),0)
LABEL(2)
	COPY(indx(pop,0),reg(1))
	DEALLOC(1)
	JUMP(pop,0)

LABEL(3)
	DEALLOC(1)
	COPY(pop,reg(1))

	movl	libr_ptr@(heap_alloc_ptr:w),a1
	movl	#symbol_type*256*65536+4,a1@+
	movl	a1,a2
	movl	d1,a1@+

	subql	#2,libr_ptr@(heap_alloc_ptr:w)
	bmis	LOCAL(5)

	movl	a1,libr_ptr@(heap_alloc_ptr:w)

	movl	a2,d1
	subql	#2,d1

	COPY(reg(1),push)
	COPY(glob(1),reg(2))
	CALL(prim(```CONS''',2),0)
	COPY(reg(1),glob(1))
	COPY(pop,reg(1))

	JUMP(pop,0)

LABEL(4)
	ERROR(wrong_type_trap)
LABEL(5)
	TRAP_HEAP
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`NUMBER?',1)					| NUMBER?
	IF_FIXNUM(reg(1),1)
	IF_FLONUM(reg(1),1)
	COPY(imm(false),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(true),reg(1))
	JUMP(reg(0),0)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`REAL?',1)					| REAL?
	IF_FIXNUM(reg(1),1)
	IF_FLONUM(reg(1),1)
	COPY(imm(false),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(true),reg(1))
	JUMP(reg(0),0)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`INTEGER?',1)					| INTEGER?
	IF_FIXNUM(reg(1),1)
	COPY(imm(false),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(true),reg(1))
	JUMP(reg(0),0)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`+')						| +
	IF_NOT_2ARGS(2)
	IF_NOT_FIXNUM(reg(1),5)
	IF_NOT_FIXNUM(reg(2),5)
	addl	d2,d1
	bvss	LOCAL(1)
	JUMP(reg(0),0)
LABEL(1)
	ERROR(arith_ovfl_trap)
LABEL(2)
	IF_NOT_1ARG(3)
	IF_NOT_FIXNUM(reg(1),5)
	JUMP(reg(0),0)
LABEL(3)
	IF_NOT_0ARG(4)
	COPY(imm(0),reg(1))
	JUMP(reg(0),0)
LABEL(4)
	ERROR(arity_trap)
LABEL(5)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`*')						| *
	IF_NOT_2ARGS(2)
	IF_NOT_FIXNUM(reg(1),5)
	IF_NOT_FIXNUM(reg(2),5)
	asrl	#3,d1
	mulsl	d2,d1
	bvss	LOCAL(1)
	JUMP(reg(0),0)
LABEL(1)
	ERROR(arith_ovfl_trap)
LABEL(2)
	IF_NOT_1ARG(3)
	IF_NOT_FIXNUM(reg(1),5)
	JUMP(reg(0),0)
LABEL(3)
	IF_NOT_0ARG(4)
	COPY(imm(8),reg(1))
	JUMP(reg(0),0)
LABEL(4)
	ERROR(arity_trap)
LABEL(5)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`-')						| -
	IF_NOT_2ARGS(2)
	IF_NOT_FIXNUM(reg(1),4)
	IF_NOT_FIXNUM(reg(2),4)
	subl	d2,d1
	bvss	LOCAL(1)
	JUMP(reg(0),0)
LABEL(1)
	ERROR(arith_ovfl_trap)
LABEL(2)
	IF_NOT_1ARG(3)
	IF_NOT_FIXNUM(reg(1),4)
	negl	d1
	bvss	LOCAL(1)
	JUMP(reg(0),0)
LABEL(3)
	ERROR(arity_trap)
LABEL(4)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`/')						| /
	IF_NOT_2ARGS(2)
	IF_NOT_FIXNUM(reg(1),4)
	IF_NOT_FIXNUM(reg(2),4)
	divsl	d2,d1
	bvss	LOCAL(1)
	asll	#3,d1
	JUMP(reg(0),0)
LABEL(1)
	ERROR(arith_ovfl_trap)
LABEL(2)
	IF_NOT_1ARG(3)
	IF_NOT_FIXNUM(reg(1),4)
	COPY(reg(1),reg(2))
	COPY(imm(8),reg(1))
	divsl	d2,d1
	bvss	LOCAL(1)
	asll	#3,d1
	JUMP(reg(0),0)
LABEL(3)
	ERROR(arity_trap)
LABEL(4)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`CHAR->INTEGER',1)				| CHAR->INTEGER
	IF_NOT_CHAR(reg(1),1)
	movl	d1,d0
	asrw	#1,d0
	moveq	#0,d1
	movb	d0,d1
	aslw	#3,d1
	JUMP(reg(0),0)
LABEL(1)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`INTEGER->CHAR',1)				| INTEGER->CHAR
	IF_NOT_FIXNUM(reg(1),2)
	cmpl	#256*8,d1
	bccs	LOCAL(1)
	asrw	#2,d1
	orl	#-131071,d1
	JUMP(reg(0),0)
LABEL(1)
	ERROR(out_bound_trap)
LABEL(2)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`MAKE-STRING')					| MAKE-STRING
	IF_NOT_1ARG(1)
	COPY(imm(0),reg(2))
	JUMP(lbl(2),0)
LABEL(1)
	IF_NOT_2ARGS(5)
	IF_NOT_CHAR(reg(2),6)
LABEL(2)
	IF_NOT_FIXNUM(reg(1),6)
	andl	d1,d1
	bmis	LOCAL(7)

	movl	libr_ptr@(heap_alloc_ptr:w),a1
	asrl	#3,d1
	movl	d1,a1@+
	movb	#string_type,a1@(-4)

	addql	#3,d1
	asrl	#2,d1
	movl	d1,d0
	addql	#1,d1
	subl	d1,libr_ptr@(free_count:w)
	bmis	LOCAL(8)

	movl	a1,d1
	subql	#2,d1

	asrl	#1,d2
	movl	d2,d3
	asll	#8,d2
	movb	d3,d2
	movw	d2,d3
	swap	d2
	movw	d3,d2
	
	bras	LOCAL(4)

LABEL(3)
	movl	d2,a1@+
LABEL(4)
	dbra	d0,LOCAL(3)

	movl	a1,libr_ptr@(heap_alloc_ptr:w)

	COPY(imm(undefined),reg(2))
	COPY(imm(undefined),reg(3))

	JUMP(reg(0),0)

LABEL(5)
	ERROR(arity_trap)
LABEL(6)
	ERROR(wrong_type_trap)
LABEL(7)
	ERROR(out_bound_trap)
LABEL(8)
	TRAP_HEAP
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`STRING-LENGTH',1)				| STRING-LENGTH
	IF_NOT_STRING(reg(1),1)
	movl	d1,a1
	movl	a1@(-2),d1
	andl	#0xffffff,d1
	asll	#3,d1
	JUMP(reg(0),0)
LABEL(1)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`STRING-REF',2)				| STRING-REF
	IF_NOT_STRING(reg(1),2)
	IF_NOT_FIXNUM(reg(2),2)
	movl	d1,a1
	movl	a1@(-2),d1
	andl	#0xffffff,d1
	movl	d2,d0
	asrl	#3,d0
	cmpl	d1,d0
	bccs	LOCAL(1)
	moveq	#0,d1
	movb	a1@(2,d0:l),d1
	aslw	#1,d1
	orl	#-131071,d1
	JUMP(reg(0),0)
LABEL(1)
	ERROR(out_bound_trap)
LABEL(2)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`STRING-SET!',3)				| STRING-SET!
	IF_NOT_STRING(reg(1),2)
	IF_NOT_FIXNUM(reg(2),2)
	IF_NOT_CHAR(reg(3),2)
	movl	d1,a1
	movl	a1@(-2),d1
	andl	#0xffffff,d1
	movl	d2,d0
	asrl	#3,d0
	cmpl	d1,d0
	bccs	LOCAL(1)
	rorw	#1,d3
	movb	d3,a1@(2,d0:l)
	movl	a1,d1
	COPY(imm(undefined),reg(3))
	JUMP(reg(0),0)
LABEL(1)
	ERROR(out_bound_trap)
LABEL(2)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`MAKE-VECTOR')					| MAKE-VECTOR
	IF_NOT_1ARG(1)
	COPY(imm(-3),reg(2))
	JUMP(lbl(2),0)
LABEL(1)
	IF_NOT_2ARGS(5)
LABEL(2)
	IF_NOT_FIXNUM(reg(1),6)
	andl	d1,d1
	bmis	LOCAL(7)

	movl	libr_ptr@(heap_alloc_ptr:w),a1
	asrl	#1,d1
	movl	d1,a1@+
	movb	#vector_type,a1@(-4)

	asrl	#2,d1
	movl	d1,d0
	addql	#1,d1
	subl	d1,libr_ptr@(free_count:w)
	bmis	LOCAL(8)

	movl	a1,d1
	subql	#2,d1

	bras	LOCAL(4)

LABEL(3)
	movl	d2,a1@+
LABEL(4)
	dbra	d0,LOCAL(3)

	movl	a1,libr_ptr@(heap_alloc_ptr:w)

	JUMP(reg(0),0)

LABEL(5)
	ERROR(arity_trap)
LABEL(6)
	ERROR(wrong_type_trap)
LABEL(7)
	ERROR(out_bound_trap)
LABEL(8)
	TRAP_HEAP
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`VECTOR-LENGTH',1)				| VECTOR-LENGTH
	IF_NOT_VECTOR(reg(1),1)
	movl	d1,a1
	movl	a1@(-2),d1
	andl	#length_mask,d1
	asll	#1,d1
	JUMP(reg(0),0)
LABEL(1)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`VECTOR-REF',2)				| VECTOR-REF
	IF_NOT_VECTOR(reg(1),2)
	IF_NOT_FIXNUM(reg(2),2)
	movl	d1,a1
	movl	a1@(-2),d1
	andl	#length_mask,d1
	movl	d2,d0
	asrl	#1,d0
	cmpl	d1,d0
	bccs	LOCAL(1)
	movl	a1@(2,d0:l),d1
	JUMP(reg(0),0)
LABEL(1)
	ERROR(out_bound_trap)
LABEL(2)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`VECTOR-SET!',3)				| VECTOR-SET!
	IF_NOT_VECTOR(reg(1),2)
	IF_NOT_FIXNUM(reg(2),2)
	movl	d1,a1
	movl	a1@(-2),d1
	andl	#length_mask,d1
	movl	d2,d0
	asrl	#1,d0
	cmpl	d1,d0
	bccs	LOCAL(1)
	movl	d3,a1@(2,d0:l)
	movl	a1,d1
	COPY(imm(undefined),reg(3))
	JUMP(reg(0),0)
LABEL(1)
	ERROR(out_bound_trap)
LABEL(2)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`PROCEDURE-INFO',1)				| PROCEDURE-INFO
	IF_NOT_PROC(reg(1),1)
	COPY(imm(0),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`APPLY',2)					| APPLY
	moveq	#0,arg_count
LABEL(1)
	IF_NOT_PAIR(reg(2),2)
	addqw	#1,arg_count
	movl	d2,a1
	movl	a1@,stack_ptr@-
	movl	a1@-,d2
	bras	LOCAL(1)
LABEL(2)
	btst	d1,hunk_mask
	beqs	LOCAL(7)
	movl	d1,a1
	tstw	a1@(-2)
	bpls	LOCAL(7)

	andw	arg_count,arg_count
	bnes	LOCAL(3)

	moveq	#1,arg_count	| 0 args
	jmp	a1@

LABEL(3)
	subqw	#1,arg_count
	bnes	LOCAL(4)

	movl	stack_ptr@+,d1
	moveq	#-1,arg_count	| 1 arg
	jmp	a1@

LABEL(4)
	subqw	#1,arg_count
	beqs	LOCAL(5)	| 2 args

	addqw	#3,arg_count	| 3 args or more
	movl	stack_ptr@+,d3
LABEL(5)
	movl	stack_ptr@+,d2
LABEL(6)
	movl	stack_ptr@+,d1
	andw	arg_count,arg_count
	jmp	a1@
LABEL(7)
	ERROR(non_proc_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`CALL-WITH-CURRENT-CONTINUATION',1)		| `CALL-WITH-CURRENT-CONTINUATION'
	COPY(reg(0),push) | save continuation

	movl	libr_ptr@(current_process:w),a2
	movl	a2@(6),a2 | get current stack
	subql	#2,a2
	movl	a2@,d0
	andl	#0xfffffc,d0
	addl	d0,a2
	movl	a2,d0
	subl	stack_ptr,d0 | d0 = length of valid portion of stack
	movl	stack_ptr,a2

	movl	libr_ptr@(heap_alloc_ptr:w),a1
	movl	d0,a1@+
	movb	#vector_type,a1@(-4)

	asrl	#2,d0
	addql	#1,d0
	subl	d0,libr_ptr@(free_count:w)
	bmi	LOCAL(6)

	pea	a1@(-2)
	subql	#1,d0

	bras	LOCAL(2)

LABEL(1)
	movl	a2@+,a1@+
LABEL(2)
	dbra	d0,LOCAL(1)

	movl	a1,libr_ptr@(heap_alloc_ptr:w)

	MAKE_CLOSURES(1)
	COPY(lbl(3),indx(stk(1),2))
	COPY(stk(2),indx(stk(1),6))

	COPY(reg(1),reg(2))
	COPY(pop,reg(1))
	DEALLOC(1)
	COPY(pop,reg(0))

	JUMP_CHECK(reg(2),0,1)

ENTRY_LABEL(3)
	ENTER_CLO(1)
	COPY(pop,temp(1)) | get closure's address
	COPY(reg(0),push) | save continuation

	movl	libr_ptr@(current_process:w),a2
	movl	a2@(6),a2 | get current stack
	subql	#2,a2
	movl	a2@,d0
	andl	#0xfffffc,d0
	addl	d0,a2
	movl	a2,d0
	subl	stack_ptr,d0
	asll	#1,d0
	movl	d0,a2@

	movl	a1@(6),a2 | get stack copy
	subql	#2,a2
	movl	a2@+,d0
	andl	#0xfffffc,d0 | d0 = length of valid portion of stack
	movl	d0,d2
	addl	#2048,d2 | d2 = total length of stack object

	movl	libr_ptr@(heap_alloc_ptr:w),a1
	pea	a1@(2)
	movl	d2,a1@+
	movb	#stack_type,a1@(-4)
	addl	d2,a1
	movl	a1,libr_ptr@(heap_alloc_ptr:w)
	asll	#1,d0
	movl	d0,a1@-
	asrl	#1,d0
	subl	d0,a1

	asrl	#2,d0
	addql	#1,d0
	subl	d0,libr_ptr@(free_count:w)
	bmis	LOCAL(6)

	subql	#1,d0

	bras	LOCAL(5)

LABEL(4)
	movl	a2@+,a1@+
LABEL(5)
	dbra	d0,LOCAL(4)

	MAKE_CLOSURES(1)
	COPY(prim(```process-transfer'''),indx(stk(1),2))
	COPY(stk(2),indx(stk(1),6))

	COPY(pop,reg(2))

	JUMP(reg(2),1,1)

LABEL(6)
	TRAP_HEAP
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`EOF-OBJECT?',1)				| EOF-OBJECT?
	cmpl	#-131067,d1
	bnes	LOCAL(1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`READ-CHAR',0)					| READ-CHAR
	moveml	d2-d7/a0/a4-a6,sp@-
	jbsr	_read_char:l
	moveml	sp@+,d2-d7/a0/a4-a6
	andl	d0,d0
	bmis	LOCAL(1)
	moveq	#0,d1
	movb	d0,d1
	aslw	#1,d1
	orl	#-131071,d1
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-131063),reg(1))
	JUMP(reg(0),0)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`PEEK-CHAR',0)					| PEEK-CHAR
	moveml	d2-d7/a0/a4-a6,sp@-
	jbsr	_peek_char:l
	moveml	sp@+,d2-d7/a0/a4-a6
	andl	d0,d0
	bmis	LOCAL(1)
	moveq	#0,d1
	movb	d0,d1
	aslw	#1,d1
	orl	#-131071,d1
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-131063),reg(1))
	JUMP(reg(0),0)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`WRITE-CHAR',1)				| WRITE-CHAR
	IF_NOT_CHAR(reg(1),1)
	moveml	d1-d7/a0/a4-a6,sp@-
	asrw	#1,d1
	movl	d1,sp@-
	jbsr	_write_char:l
	addql	#4,sp
	moveml	sp@+,d1-d7/a0/a4-a6
	JUMP(reg(0),0)
LABEL(1)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`EXIT',1)					| EXIT
	IF_NOT_FIXNUM(reg(1),1)
	moveml	d1-d7/a0/a4-a6,sp@-
	asrl	#3,d1
	movl	d1,sp@-
	jbsr	_exit:l
	addql	#4,sp
	moveml	sp@+,d1-d7/a0/a4-a6
	JUMP(reg(0),0)
LABEL(1)
	ERROR(wrong_type_trap)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`CURRENT-PROCESS',0)				| CURRENT-PROCESS
	movl	libr_ptr@(current_process:w),d1
	JUMP(reg(0),0)
END

|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`CPU-TIME',0)					| CPU-TIME
	moveml	d1-d7/a0/a4-a6,sp@-
	jbsr	_cpu_time:l
	moveml	sp@+,d1-d7/a0/a4-a6
	asll	#3,d0
	movl	d0,d1
	JUMP(reg(0),0)
END

	COPY(prim(```CURRENT-PROCESS'''),glob(123))
	COPY(prim(```CPU-TIME'''),glob(124))
|------------------------------------------------------------------------------

DEFINE_PRIMITIVE(`NOT',1)
	IF(reg(1),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`BOOLEAN?',1)
	IF_NOT_EQ(reg(1),imm(-5),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(2))
	JUMP(prim(```EQ?''',2),0)
END

DEFINE_PRIMITIVE(`EQV?',2)
	IF_NOT_EQ(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`EQ?',2)
	IF_NOT_EQ(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`EQUAL?',2)
	IF_NOT_EQ(reg(1),reg(2),3)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(3)
	IF_NOT_PAIR(reg(1),4)
	IF_NOT_PAIR(reg(2),5)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	OPEN_CODE(prim(```CAR''',1),reg(2),reg(1))
	COPY(reg(1),push)
	OPEN_CODE(prim(```CAR''',1),stk(3),reg(1))
	COPY(pop,reg(2))
	CALL(prim(```EQUAL?''',2),0)
	IF_NOT(reg(1),6)
	OPEN_CODE(prim(```CDR''',1),pop,reg(1))
	COPY(reg(1),push)
	OPEN_CODE(prim(```CDR''',1),stk(2),reg(1))
	COPY(pop,reg(2))
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(prim(```EQUAL?''',2),0)
LABEL(6)
	COPY(imm(-1),reg(1))
	DEALLOC(2)
	JUMP(pop,0)
LABEL(5)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
LABEL(4)
	IF_NOT_VECTOR(reg(1),7)
	IF_NOT_VECTOR(reg(2),8)
	JUMP(lbl(2),0)
LABEL(8)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
LABEL(7)
	IF_NOT_STRING(reg(1),9)
	IF_NOT_STRING(reg(2),10)
	JUMP(prim(```STRING=?''',2),0)
LABEL(10)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
LABEL(9)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
ENTRY_LABEL(1)
	ENTER(2)
LABEL(2)
	CHECK_STACK
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	CALL(prim(```VECTOR-LENGTH''',1),0)
	COPY(reg(1),push)
	COPY(stk(2),reg(1))
	CALL(prim(```VECTOR-LENGTH''',1),0)
	IF_NOT_EQ(stk(1),reg(1),11)
	OPEN_CODE(prim(```-''',2),pop,imm(8),reg(1))
	COPY(reg(1),reg(3))
	COPY(pop,reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(13),0)
LABEL(11)
	COPY(imm(-1),reg(1))
	DEALLOC(3)
	JUMP(pop,0)
ENTRY_LABEL(12)
	ENTER(3)
LABEL(13)
	CHECK_STACK
	IF_NOT_LT(reg(3),imm(0),14)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(14)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(reg(3),push)
	COPY(reg(3),reg(2))
	COPY(stk(2),reg(1))
	CALL(prim(```VECTOR-REF''',2),0)
	COPY(reg(1),push)
	COPY(stk(2),reg(2))
	COPY(stk(4),reg(1))
	CALL(prim(```VECTOR-REF''',2),0)
	COPY(pop,reg(2))
	CALL(prim(```EQUAL?''',2),0)
	IF_NOT(reg(1),15)
	OPEN_CODE(prim(```-''',2),pop,imm(8),reg(1))
	COPY(reg(1),reg(3))
	COPY(pop,reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(13),0)
LABEL(15)
	COPY(imm(-1),reg(1))
	DEALLOC(3)
	JUMP(pop,0)
END

DEFINE_PRIMITIVE(`PAIR?',1)
	IF_NOT_PAIR(reg(1),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`CAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj1)
END

DEFINE_PRIMITIVE(`CDR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj2)
END

DEFINE_PRIMITIVE(`SET-CAR!',2)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```SET-CAR!''',2),reg(1),reg(2),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj3)
END

DEFINE_PRIMITIVE(`SET-CDR!',2)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```SET-CDR!''',2),reg(1),reg(2),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj4)
END

DEFINE_PRIMITIVE(`CAAR',1)
	IF_NOT_PAIR(reg(1),3)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(2))
	IF_NOT_PAIR(reg(2),4)
	OPEN_CODE(prim(```CAR''',1),reg(2),reg(1))
	JUMP(reg(0),0)
LABEL(4)
	JUMP(lbl(2),0)
LABEL(3)
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(1)
LABEL(2)
	CHECK_STACK
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj5)
END

DEFINE_PRIMITIVE(`CADR',1)
	IF_NOT_PAIR(reg(1),3)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(2))
	IF_NOT_PAIR(reg(2),4)
	OPEN_CODE(prim(```CAR''',1),reg(2),reg(1))
	JUMP(reg(0),0)
LABEL(4)
	JUMP(lbl(2),0)
LABEL(3)
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(1)
LABEL(2)
	CHECK_STACK
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj6)
END

DEFINE_PRIMITIVE(`CDAR',1)
	IF_NOT_PAIR(reg(1),3)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(2))
	IF_NOT_PAIR(reg(2),4)
	OPEN_CODE(prim(```CDR''',1),reg(2),reg(1))
	JUMP(reg(0),0)
LABEL(4)
	JUMP(lbl(2),0)
LABEL(3)
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(1)
LABEL(2)
	CHECK_STACK
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj7)
END

DEFINE_PRIMITIVE(`CDDR',1)
	IF_NOT_PAIR(reg(1),3)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(2))
	IF_NOT_PAIR(reg(2),4)
	OPEN_CODE(prim(```CDR''',1),reg(2),reg(1))
	JUMP(reg(0),0)
LABEL(4)
	JUMP(lbl(2),0)
LABEL(3)
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(1)
LABEL(2)
	CHECK_STACK
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj8)
END

DEFINE_PRIMITIVE(`CAAAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CAAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj9)
END

DEFINE_PRIMITIVE(`CAADR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CAAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj10)
END

DEFINE_PRIMITIVE(`CADAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CADR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj11)
END

DEFINE_PRIMITIVE(`CADDR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CADR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj12)
END

DEFINE_PRIMITIVE(`CDAAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CDAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj13)
END

DEFINE_PRIMITIVE(`CDADR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CDAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj14)
END

DEFINE_PRIMITIVE(`CDDAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CDDR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj15)
END

DEFINE_PRIMITIVE(`CDDDR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CDDR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj16)
END

DEFINE_PRIMITIVE(`CAAAAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CAAAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj17)
END

DEFINE_PRIMITIVE(`CAAADR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CAAAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj18)
END

DEFINE_PRIMITIVE(`CAADAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CAADR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj19)
END

DEFINE_PRIMITIVE(`CAADDR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CAADR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj20)
END

DEFINE_PRIMITIVE(`CADAAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CADAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj21)
END

DEFINE_PRIMITIVE(`CADADR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CADAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj22)
END

DEFINE_PRIMITIVE(`CADDAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CADDR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj23)
END

DEFINE_PRIMITIVE(`CADDDR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CADDR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj24)
END

DEFINE_PRIMITIVE(`CDAAAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CDAAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj25)
END

DEFINE_PRIMITIVE(`CDAADR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CDAAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj26)
END

DEFINE_PRIMITIVE(`CDADAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CDADR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj27)
END

DEFINE_PRIMITIVE(`CDADDR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CDADR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj28)
END

DEFINE_PRIMITIVE(`CDDAAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CDDAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj29)
END

DEFINE_PRIMITIVE(`CDDADR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CDDAR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj30)
END

DEFINE_PRIMITIVE(`CDDDAR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	JUMP(prim(```CDDDR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj31)
END

DEFINE_PRIMITIVE(`CDDDDR',1)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```CDDDR''',1),0)
LABEL(1)
	COPY(reg(1),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj32)
END

DEFINE_PRIMITIVE(`NULL?',1)
	IF_NOT_NULL(reg(1),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`LIST',1,REST)
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`LENGTH',1)
	COPY(imm(0),reg(2))
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(2)
LABEL(2)
	CHECK_STACK
	IF_NOT_PAIR(reg(1),3)
	OPEN_CODE(prim(```+''',2),reg(2),imm(8),reg(2))
	COPY(reg(2),push)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	COPY(pop,reg(2))
	JUMP(lbl(2),0)
LABEL(3)
	COPY(reg(2),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`APPEND',2)
	IF_NOT_PAIR(reg(1),1)
	COPY(reg(0),push)
	COPY(reg(1),push)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	CALL(prim(```APPEND''',2),0)
	COPY(reg(1),push)
	OPEN_CODE(prim(```CAR''',1),stk(2),reg(1))
	COPY(pop,reg(2))
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(prim(```CONS''',2),0)
LABEL(1)
	COPY(reg(2),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`REVERSE',1)
	COPY(imm(-3),reg(2))
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(2)
LABEL(2)
	CHECK_STACK
	IF_NOT_PAIR(reg(1),3)
	COPY(reg(0),push)
	COPY(reg(1),push)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	CALL(prim(```CONS''',2),0)
	COPY(reg(1),push)
	OPEN_CODE(prim(```CDR''',1),stk(2),reg(1))
	COPY(pop,reg(2))
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(lbl(2),0)
LABEL(3)
	COPY(reg(2),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`LIST-TAIL',2)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(reg(2),reg(1))
	CALL(prim(```INTEGER?''',1),0)
	IF(reg(1),1)
	COPY(stk(1),reg(2))
	COPY(const(1),reg(1))
	CALL(prim(```ERROR'''),0,2)
LABEL(1)
	IF_NOT_LT(stk(1),imm(0),2)
	COPY(stk(1),reg(2))
	COPY(const(2),reg(1))
	CALL(prim(```ERROR'''),0,2)
LABEL(2)
	COPY(pop,reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(4),0)
ENTRY_LABEL(3)
	ENTER(2)
LABEL(4)
	CHECK_STACK
	IF_NOT_EQ(reg(2),imm(0),5)
	JUMP(reg(0),0)
LABEL(5)
	IF_NOT_PAIR(reg(1),6)
	OPEN_CODE(prim(```-''',2),reg(2),imm(8),reg(2))
	COPY(reg(2),push)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	COPY(pop,reg(2))
	JUMP(prim(```LIST-TAIL''',2),0)
LABEL(6)
	COPY(reg(1),reg(2))
	COPY(const(3),reg(1))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj33)
CONST(obj34)
CONST(obj35)
END

DEFINE_PRIMITIVE(`LIST-REF',2)
	COPY(reg(0),push)
	COPY(reg(1),push)
	CALL(prim(```LIST-TAIL''',2),0)
	IF_NOT_PAIR(reg(1),1)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	DEALLOC(1)
	JUMP(pop,0)
LABEL(1)
	COPY(pop,reg(2))
	COPY(const(1),reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```ERROR'''),0,2)
CONST(obj36)
END

DEFINE_PRIMITIVE(`LAST-PAIR',1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(2))
	IF_NOT_PAIR(reg(2),1)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	JUMP(prim(```LAST-PAIR''',1),0)
LABEL(1)
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`MEMQ',2)
	IF_NOT_PAIR(reg(2),1)
	OPEN_CODE(prim(```CAR''',1),reg(2),reg(3))
	IF_NOT_EQ(reg(3),reg(1),2)
	COPY(reg(2),reg(1))
	JUMP(reg(0),0)
LABEL(2)
	OPEN_CODE(prim(```CDR''',1),reg(2),reg(2))
	JUMP(prim(```MEMQ''',2),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`MEMV',2)
	IF_NOT_PAIR(reg(2),1)
	OPEN_CODE(prim(```CAR''',1),reg(2),reg(3))
	IF_NOT_EQ(reg(3),reg(1),2)
	COPY(reg(2),reg(1))
	JUMP(reg(0),0)
LABEL(2)
	OPEN_CODE(prim(```CDR''',1),reg(2),reg(2))
	JUMP(prim(```MEMV''',2),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`MEMBER',2)
	IF_NOT_PAIR(reg(2),1)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	OPEN_CODE(prim(```CAR''',1),reg(2),reg(1))
	COPY(stk(2),reg(2))
	CALL(prim(```EQUAL?''',2),0)
	IF_NOT(reg(1),2)
	COPY(pop,reg(1))
	DEALLOC(1)
	JUMP(pop,0)
LABEL(2)
	OPEN_CODE(prim(```CDR''',1),pop,reg(1))
	COPY(reg(1),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```MEMBER''',2),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`ASSQ',2)
	IF_NOT_PAIR(reg(2),1)
	OPEN_CODE(prim(```CAR''',1),reg(2),reg(3))
	IF_NOT_PAIR(reg(3),2)
	OPEN_CODE(prim(```CAR''',1),reg(3),push)
	IF_NOT_EQ(pop,reg(1),3)
	COPY(reg(3),reg(1))
	JUMP(reg(0),0)
LABEL(3)
	OPEN_CODE(prim(```CDR''',1),reg(2),reg(2))
	JUMP(prim(```ASSQ''',2),0)
LABEL(2)
	COPY(reg(3),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
CONST(obj37)
END

DEFINE_PRIMITIVE(`ASSV',2)
	IF_NOT_PAIR(reg(2),1)
	OPEN_CODE(prim(```CAR''',1),reg(2),reg(3))
	IF_NOT_PAIR(reg(3),2)
	OPEN_CODE(prim(```CAR''',1),reg(3),push)
	IF_NOT_EQ(pop,reg(1),3)
	COPY(reg(3),reg(1))
	JUMP(reg(0),0)
LABEL(3)
	OPEN_CODE(prim(```CDR''',1),reg(2),reg(2))
	JUMP(prim(```ASSV''',2),0)
LABEL(2)
	COPY(reg(3),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
CONST(obj38)
END

DEFINE_PRIMITIVE(`ASSOC',2)
	IF_NOT_PAIR(reg(2),1)
	OPEN_CODE(prim(```CAR''',1),reg(2),reg(3))
	IF_NOT_PAIR(reg(3),2)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(reg(3),push)
	OPEN_CODE(prim(```CAR''',1),reg(3),reg(1))
	COPY(stk(3),reg(2))
	CALL(prim(```EQUAL?''',2),0)
	IF_NOT(reg(1),3)
	COPY(pop,reg(1))
	DEALLOC(2)
	JUMP(pop,0)
LABEL(3)
	DEALLOC(1)
	OPEN_CODE(prim(```CDR''',1),pop,reg(1))
	COPY(reg(1),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```ASSOC''',2),0)
LABEL(2)
	COPY(reg(3),reg(2))
	COPY(const(1),reg(1))
	JUMP(prim(```ERROR'''),0,2)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
CONST(obj39)
END

DEFINE_PRIMITIVE(`SYMBOL?',1)
	IF_NOT_SYMBOL(reg(1),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`ODD?',1)
	COPY(reg(0),push)
	CALL(prim(```EVEN?''',1),0)
	COPY(pop,reg(0))
	JUMP(prim(```NOT''',1),0)
END

DEFINE_PRIMITIVE(`EVEN?',1)
	COPY(reg(0),push)
	COPY(imm(16),reg(2))
	CALL(prim(```REMAINDER''',2),0)
	COPY(imm(0),reg(2))
	COPY(pop,reg(0))
	JUMP(prim(```=''',2),0)
END

DEFINE_PRIMITIVE(`=',2)
	IF_NOT_EQ(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`<',2)
	IF_NOT_LT(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`>',2)
	IF_NOT_GT(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`<=',2)
	IF_GT(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`>=',2)
	IF_LT(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`MAX',2)
	IF_NOT_GT(reg(1),reg(2),1)
	JUMP(reg(0),0)
LABEL(1)
	COPY(reg(2),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`MIN',2)
	IF_NOT_LT(reg(1),reg(2),1)
	JUMP(reg(0),0)
LABEL(1)
	COPY(reg(2),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`ABS',1)
	IF_NOT_LT(reg(1),imm(0),1)
	JUMP(prim(```-''',1),0)
LABEL(1)
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`QUOTIENT',2)
	OPEN_CODE(prim(```/''',2),reg(1),reg(2),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`REMAINDER',2)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	CALL(prim(```QUOTIENT''',2),0)
	OPEN_CODE(prim(```*''',2),reg(1),pop,reg(1))
	OPEN_CODE(prim(```-''',2),pop,reg(1),reg(1))
	JUMP(pop,0)
END

DEFINE_PRIMITIVE(`EXPT',2)
	IF_NOT_EQ(reg(2),imm(0),1)
	COPY(imm(8),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(imm(16),reg(2))
	COPY(stk(1),reg(1))
	CALL(prim(```QUOTIENT''',2),0)
	COPY(reg(1),push)
	OPEN_CODE(prim(```*''',2),stk(3),stk(3),reg(1))
	COPY(pop,reg(2))
	CALL(prim(```EXPT''',2),0)
	COPY(reg(1),push)
	COPY(stk(2),reg(1))
	CALL(prim(```ODD?''',1),0)
	IF_NOT(reg(1),2)
	OPEN_CODE(prim(```*''',2),stk(3),pop,reg(1))
	DEALLOC(2)
	JUMP(pop,0)
LABEL(2)
	COPY(pop,reg(1))
	DEALLOC(2)
	JUMP(pop,0)
END

DEFINE_PRIMITIVE(`NUMBER->STRING',1)
	IF_NOT_LT(reg(1),imm(0),3)
	COPY(reg(0),push)
	CALL(prim(```-''',1),0)
	COPY(reg(1),reg(2))
	COPY(imm(8),reg(3))
	COPY(imm(8),reg(1))
	CALL(lbl(2),0)
	COPY(imm(-130981),reg(3))
	COPY(imm(0),reg(2))
	COPY(pop,reg(0))
	JUMP(prim(```STRING-SET!''',3),0)
LABEL(3)
	COPY(imm(8),reg(3))
	COPY(reg(1),reg(2))
	COPY(imm(0),reg(1))
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(3)
LABEL(2)
	CHECK_STACK
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(reg(3),push)
	COPY(imm(80),reg(2))
	COPY(stk(2),reg(1))
	CALL(prim(```QUOTIENT''',2),0)
	COPY(reg(1),push)
	IF_NOT_EQ(reg(1),imm(0),4)
	OPEN_CODE(prim(```+''',2),stk(2),stk(4),reg(1))
	CALL(prim(```MAKE-STRING''',1),0)
	JUMP(lbl(5),0)
LABEL(4)
	OPEN_CODE(prim(```+''',2),stk(2),imm(8),reg(1))
	COPY(reg(1),reg(3))
	COPY(stk(1),reg(2))
	COPY(stk(4),reg(1))
	CALL(lbl(2),0)
LABEL(5)
	COPY(reg(1),stk(4))
	OPEN_CODE(prim(```*''',2),pop,imm(80),reg(1))
	OPEN_CODE(prim(```-''',2),stk(2),reg(1),reg(1))
	OPEN_CODE(prim(```+''',2),imm(384),reg(1),reg(1))
	CALL(prim(```INTEGER->CHAR''',1),0)
	COPY(reg(1),push)
	COPY(stk(4),reg(1))
	CALL(prim(```STRING-LENGTH''',1),0)
	OPEN_CODE(prim(```-''',2),reg(1),stk(2),reg(1))
	COPY(reg(1),reg(2))
	COPY(stk(4),reg(1))
	COPY(pop,reg(3))
	DEALLOC(3)
	COPY(pop,reg(0))
	JUMP(prim(```STRING-SET!''',3),0)
END

DEFINE_PRIMITIVE(`STRING->NUMBER',1)
	COPY(reg(0),push)
	COPY(reg(1),push)
	CALL(prim(```STRING-LENGTH''',1),0)
	COPY(imm(0),reg(2))
	CALL(prim(```>''',2),0)
	IF_NOT(reg(1),3)
	COPY(imm(0),reg(2))
	COPY(stk(1),reg(1))
	CALL(prim(```STRING-REF''',2),0)
	IF_NOT_EQ(reg(1),imm(-130981),4)
	COPY(stk(1),reg(1))
	CALL(prim(```STRING-LENGTH''',1),0)
	COPY(imm(8),reg(2))
	CALL(prim(```>''',2),0)
	IF_NOT(reg(1),5)
	COPY(imm(0),reg(3))
	COPY(imm(8),reg(2))
	COPY(pop,reg(1))
	CALL(lbl(2),0)
	COPY(reg(1),push)
	IF_NOT(stk(1),6)
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(prim(```-''',1),0)
LABEL(6)
	COPY(pop,reg(1))
	JUMP(pop,0)
LABEL(5)
	DEALLOC(1)
	JUMP(pop,0)
LABEL(4)
	COPY(imm(0),reg(2))
	COPY(stk(1),reg(1))
	CALL(prim(```STRING-REF''',2),0)
	IF_NOT_EQ(reg(1),imm(-130985),7)
	COPY(stk(1),reg(1))
	CALL(prim(```STRING-LENGTH''',1),0)
	COPY(imm(8),reg(2))
	CALL(prim(```>''',2),0)
	IF_NOT(reg(1),8)
	COPY(imm(0),reg(3))
	COPY(imm(8),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(2),0)
LABEL(8)
	DEALLOC(1)
	JUMP(pop,0)
LABEL(7)
	COPY(imm(0),reg(3))
	COPY(imm(0),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(2),0)
LABEL(3)
	DEALLOC(1)
	JUMP(pop,0)
ENTRY_LABEL(1)
	ENTER(3)
LABEL(2)
	CHECK_STACK
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(reg(3),push)
	CALL(prim(```STRING-REF''',2),0)
	COPY(reg(1),push)
	COPY(imm(-130975),reg(2))
	CALL(prim(```CHAR>=?''',2),0)
	IF_NOT(reg(1),9)
	COPY(imm(-130957),reg(2))
	COPY(stk(1),reg(1))
	CALL(prim(```CHAR<=?''',2),0)
	IF_NOT(reg(1),10)
	OPEN_CODE(prim(```+''',2),stk(3),imm(8),reg(1))
	OPEN_CODE(prim(```*''',2),stk(2),imm(80),reg(2))
	COPY(reg(1),stk(3))
	COPY(reg(2),stk(2))
	COPY(pop,reg(1))
	CALL(prim(```CHAR->INTEGER''',1),0)
	OPEN_CODE(prim(```-''',2),reg(1),imm(384),reg(1))
	OPEN_CODE(prim(```+''',2),pop,reg(1),reg(1))
	COPY(reg(1),push)
	COPY(stk(3),reg(1))
	CALL(prim(```STRING-LENGTH''',1),0)
	IF_NOT_EQ(reg(1),stk(2),11)
	COPY(pop,reg(1))
	DEALLOC(2)
	JUMP(pop,0)
LABEL(11)
	COPY(pop,reg(3))
	COPY(pop,reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(2),0)
LABEL(10)
	DEALLOC(4)
	JUMP(pop,0)
LABEL(9)
	DEALLOC(4)
	JUMP(pop,0)
END

DEFINE_PRIMITIVE(`CHAR?',1)
	IF_NOT_CHAR(reg(1),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`CHAR=?',2)
	IF_NOT_EQ(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`CHAR<?',2)
	IF_NOT_LT(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`CHAR>?',2)
	IF_NOT_GT(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`CHAR<=?',2)
	IF_GT(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`CHAR>=?',2)
	IF_LT(reg(1),reg(2),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`CHAR-UPPERCASE',1)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(imm(-130877),reg(2))
	CALL(prim(```CHAR>=?''',2),0)
	IF_NOT(reg(1),1)
	COPY(imm(-130827),reg(2))
	COPY(stk(1),reg(1))
	CALL(prim(```CHAR<=?''',2),0)
LABEL(1)
	IF_NOT(reg(1),2)
	COPY(pop,reg(1))
	CALL(prim(```CHAR->INTEGER''',1),0)
	OPEN_CODE(prim(```-''',2),reg(1),imm(256),reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```INTEGER->CHAR''',1),0)
LABEL(2)
	COPY(pop,reg(1))
	JUMP(pop,0)
END

DEFINE_PRIMITIVE(`STRING?',1)
	IF_NOT_STRING(reg(1),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`STRING=?',2)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	CALL(prim(```STRING-LENGTH''',1),0)
	COPY(reg(1),push)
	COPY(stk(2),reg(1))
	CALL(prim(```STRING-LENGTH''',1),0)
	IF_NOT_EQ(pop,reg(1),1)
	COPY(stk(2),reg(1))
	CALL(prim(```STRING-LENGTH''',1),0)
	OPEN_CODE(prim(```-''',2),reg(1),imm(8),reg(1))
	COPY(reg(1),reg(3))
	COPY(pop,reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(3),0)
LABEL(1)
	DEALLOC(2)
	JUMP(pop,0)
ENTRY_LABEL(2)
	ENTER(3)
LABEL(3)
	CHECK_STACK
	IF_NOT_LT(reg(3),imm(0),4)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(4)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(reg(3),push)
	COPY(reg(3),reg(2))
	CALL(prim(```STRING-REF''',2),0)
	COPY(reg(1),push)
	COPY(stk(2),reg(2))
	COPY(stk(3),reg(1))
	CALL(prim(```STRING-REF''',2),0)
	IF_NOT_EQ(pop,reg(1),5)
	OPEN_CODE(prim(```-''',2),pop,imm(8),reg(1))
	COPY(reg(1),reg(3))
	COPY(pop,reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(3),0)
LABEL(5)
	COPY(imm(-1),reg(1))
	DEALLOC(3)
	JUMP(pop,0)
END

DEFINE_PRIMITIVE(`STRING->LIST',1)
	COPY(reg(0),push)
	COPY(reg(1),push)
	CALL(prim(```STRING-LENGTH''',1),0)
	OPEN_CODE(prim(```-''',2),reg(1),imm(8),reg(1))
	COPY(reg(1),reg(3))
	COPY(imm(-3),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(3)
LABEL(2)
	CHECK_STACK
	IF_NOT_LT(reg(3),imm(0),3)
	COPY(reg(2),reg(1))
	JUMP(reg(0),0)
LABEL(3)
	OPEN_CODE(prim(```-''',2),reg(3),imm(8),push)
	COPY(stk(1),push)
	COPY(reg(0),stk(2))
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(reg(3),reg(2))
	CALL(prim(```STRING-REF''',2),0)
	COPY(pop,reg(2))
	CALL(prim(```CONS''',2),0)
	COPY(reg(1),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(3))
	COPY(pop,reg(0))
	JUMP(lbl(2),0)
END

DEFINE_PRIMITIVE(`LIST->STRING',1)
	COPY(imm(0),reg(2))
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(2)
LABEL(2)
	CHECK_STACK
	IF_NOT_PAIR(reg(1),3)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(3))
	COPY(reg(3),push)
	COPY(reg(0),push)
	COPY(reg(2),push)
	OPEN_CODE(prim(```+''',2),reg(2),imm(8),reg(2))
	COPY(reg(2),push)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	COPY(pop,reg(2))
	CALL(lbl(2),0)
	COPY(pop,reg(2))
	COPY(stk(2),reg(3))
	COPY(pop,reg(0))
	JUMP(prim(```STRING-SET!''',3),1)
LABEL(3)
	COPY(reg(2),reg(1))
	JUMP(prim(```MAKE-STRING''',1),0)
END

DEFINE_PRIMITIVE(`VECTOR?',1)
	IF_NOT_VECTOR(reg(1),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`VECTOR',1,REST)
	JUMP(prim(```LIST->VECTOR''',1),0)
END

DEFINE_PRIMITIVE(`VECTOR->LIST',1)
	COPY(reg(0),push)
	COPY(reg(1),push)
	CALL(prim(```VECTOR-LENGTH''',1),0)
	OPEN_CODE(prim(```-''',2),reg(1),imm(8),reg(1))
	COPY(reg(1),reg(3))
	COPY(imm(-3),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(3)
LABEL(2)
	CHECK_STACK
	IF_NOT_LT(reg(3),imm(0),3)
	COPY(reg(2),reg(1))
	JUMP(reg(0),0)
LABEL(3)
	OPEN_CODE(prim(```-''',2),reg(3),imm(8),push)
	COPY(stk(1),push)
	COPY(reg(0),stk(2))
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(reg(3),reg(2))
	CALL(prim(```VECTOR-REF''',2),0)
	COPY(pop,reg(2))
	CALL(prim(```CONS''',2),0)
	COPY(reg(1),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(3))
	COPY(pop,reg(0))
	JUMP(lbl(2),0)
END

DEFINE_PRIMITIVE(`LIST->VECTOR',1)
	COPY(imm(0),reg(2))
	JUMP(lbl(2),0)
ENTRY_LABEL(1)
	ENTER(2)
LABEL(2)
	CHECK_STACK
	IF_NOT_PAIR(reg(1),3)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(3))
	COPY(reg(3),push)
	COPY(reg(0),push)
	COPY(reg(2),push)
	OPEN_CODE(prim(```+''',2),reg(2),imm(8),reg(2))
	COPY(reg(2),push)
	OPEN_CODE(prim(```CDR''',1),reg(1),reg(1))
	COPY(pop,reg(2))
	CALL(lbl(2),0)
	COPY(pop,reg(2))
	COPY(stk(2),reg(3))
	COPY(pop,reg(0))
	JUMP(prim(```VECTOR-SET!''',3),1)
LABEL(3)
	COPY(reg(2),reg(1))
	JUMP(prim(```MAKE-VECTOR''',1),0)
END

DEFINE_PRIMITIVE(`PROCEDURE?',1)
	IF_NOT_PROC(reg(1),1)
	COPY(imm(-5),reg(1))
	JUMP(reg(0),0)
LABEL(1)
	COPY(imm(-1),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`MAP',2)
	IF_NOT_PAIR(reg(2),1)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	OPEN_CODE(prim(```CDR''',1),reg(2),reg(1))
	COPY(reg(1),reg(2))
	COPY(stk(2),reg(1))
	CALL(prim(```MAP''',2),0)
	COPY(reg(1),push)
	OPEN_CODE(prim(```CAR''',1),stk(2),reg(1))
	CALL_CHECK(stk(3),0,1)
	COPY(pop,reg(2))
	DEALLOC(2)
	COPY(pop,reg(0))
	JUMP(prim(```CONS''',2),0)
LABEL(1)
	COPY(imm(-3),reg(1))
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`FOR-EACH',2)
	IF_NOT_PAIR(reg(2),1)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	OPEN_CODE(prim(```CAR''',1),reg(2),reg(1))
	CALL_CHECK(stk(2),0,1)
	OPEN_CODE(prim(```CDR''',1),pop,reg(1))
	COPY(reg(1),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```FOR-EACH''',2),0)
LABEL(1)
	JUMP(reg(0),0)
END

DEFINE_PRIMITIVE(`MAKE-DELAYED',1)
	COPY(reg(1),reg(2))
	COPY(imm(-1),reg(1))
	JUMP(prim(```CONS''',2),0)
END

DEFINE_PRIMITIVE(`FORCE',1)
	COPY(reg(0),push)
	COPY(reg(1),push)
	OPEN_CODE(prim(```CAR''',1),reg(1),reg(1))
	IF(reg(1),1)
	OPEN_CODE(prim(```CDR''',1),stk(1),reg(1))
	CALL_CHECK(reg(1),0,0)
	OPEN_CODE(prim(```SET-CDR!''',2),stk(1),reg(1),reg(1))
	OPEN_CODE(prim(```SET-CAR!''',2),stk(1),imm(-5),reg(1))
LABEL(1)
	OPEN_CODE(prim(```CDR''',1),pop,reg(1))
	JUMP(pop,0)
END

DEFINE_PRIMITIVE(`READ',0)
	COPY(reg(0),push)
	CALL(lbl(8),0)
	COPY(pop,reg(0))
	JUMP(lbl(14),0)
ENTRY_LABEL(1)
	ENTER(1)
LABEL(2)
	CHECK_STACK
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(imm(-131007),reg(2))
	CALL(prim(```CHAR<=?''',2),0)
	IF_NOT(reg(1),15)
	DEALLOC(1)
	JUMP(pop,0)
LABEL(15)
	COPY(const(1),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```MEMQ''',2),0)
ENTRY_LABEL(3)
	ENTER(0)
LABEL(4)
	CHECK_STACK
	COPY(imm(0),reg(1))
	JUMP(lbl(17),0)
ENTRY_LABEL(5)
	ENTER(1)
LABEL(6)
	CHECK_STACK
	COPY(reg(0),push)
	CALL(prim(```CHAR-UPPERCASE''',1),0)
	COPY(reg(1),push)
	COPY(imm(8),reg(1))
	CALL(lbl(19),0)
	COPY(imm(0),reg(2))
	COPY(pop,reg(3))
	COPY(pop,reg(0))
	JUMP(prim(```STRING-SET!''',3),0)
ENTRY_LABEL(7)
	ENTER(0)
LABEL(8)
	CHECK_STACK
	COPY(reg(0),push)
	CALL(prim(```READ-CHAR''',0),0)
	COPY(reg(1),push)
	CALL(prim(```EOF-OBJECT?''',1),0)
	IF_NOT(reg(1),20)
	COPY(pop,reg(1))
	JUMP(pop,0)
LABEL(20)
	IF_GT(stk(1),imm(-131007),21)
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(lbl(8),0)
LABEL(21)
	COPY(pop,reg(1))
	JUMP(pop,0)
ENTRY_LABEL(9)
	ENTER(1)
LABEL(10)
	CHECK_STACK
	COPY(reg(0),push)
	COPY(reg(1),push)
	CALL(lbl(8),0)
	IF_NOT_EQ(reg(1),imm(-130989),22)
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```LIST'''),0,1)
LABEL(22)
	IF_NOT_EQ(reg(1),imm(-130979),23)
	CALL(prim(```READ''',0),0)
	COPY(reg(1),push)
	CALL(lbl(8),0)
	IF_NOT_EQ(reg(1),imm(-130989),24)
	COPY(pop,reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```CONS''',2),0)
LABEL(24)
	COPY(const(2),reg(1))
	DEALLOC(2)
	COPY(pop,reg(0))
	JUMP(prim(```ERROR'''),0,1)
LABEL(23)
	CALL(lbl(14),0)
	CALL(lbl(10),0)
	COPY(reg(1),reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```CONS''',2),0)
ENTRY_LABEL(11)
	ENTER(0)
LABEL(12)
	CHECK_STACK
	COPY(imm(0),reg(1))
	JUMP(lbl(26),0)
ENTRY_LABEL(13)
	ENTER(1)
LABEL(14)
	CHECK_STACK
	COPY(reg(0),push)
	COPY(reg(1),push)
	CALL(prim(```EOF-OBJECT?''',1),0)
	IF_NOT(reg(1),27)
	COPY(pop,reg(1))
	JUMP(pop,0)
LABEL(27)
	IF_NOT_EQ(stk(1),imm(-130991),28)
	CALL(prim(```PEEK-CHAR''',0),1)
	IF_NOT_EQ(reg(1),imm(-130989),29)
	CALL(prim(```READ-CHAR''',0),0)
	COPY(imm(-3),reg(1))
	JUMP(pop,0)
LABEL(29)
	CALL(prim(```READ''',0),0)
	COPY(pop,reg(0))
	JUMP(lbl(10),0)
LABEL(28)
	IF_NOT_EQ(stk(1),imm(-131001),30)
	CALL(prim(```READ-CHAR''',0),1)
	CALL(prim(```CHAR-UPPERCASE''',1),0)
	IF_NOT_EQ(reg(1),imm(-130991),31)
	COPY(pop,reg(0))
	JUMP(lbl(12),0)
LABEL(31)
	IF_NOT_EQ(reg(1),imm(-130887),32)
	COPY(pop,reg(0))
	JUMP(prim(```READ-CHAR''',0),0)
LABEL(32)
	IF_NOT_EQ(reg(1),imm(-130931),33)
	COPY(imm(-1),reg(1))
	JUMP(pop,0)
LABEL(33)
	IF_NOT_EQ(reg(1),imm(-130903),34)
	COPY(imm(-5),reg(1))
	JUMP(pop,0)
LABEL(34)
	COPY(reg(1),reg(2))
	COPY(const(3),reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```ERROR'''),0,2)
LABEL(30)
	IF_NOT_EQ(stk(1),imm(-131003),35)
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(lbl(4),0)
LABEL(35)
	IF_NOT_EQ(stk(1),imm(-130993),36)
	CALL(prim(```READ''',0),1)
	COPY(reg(1),reg(2))
	COPY(const(4),reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```LIST'''),0,2)
LABEL(36)
	IF_NOT_EQ(stk(1),imm(-130879),37)
	CALL(prim(```READ''',0),1)
	COPY(reg(1),reg(2))
	COPY(const(5),reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```LIST'''),0,2)
LABEL(37)
	IF_NOT_EQ(stk(1),imm(-130983),38)
	CALL(prim(```PEEK-CHAR''',0),1)
	IF_NOT_EQ(reg(1),imm(-130943),39)
	CALL(prim(```READ-CHAR''',0),0)
	CALL(prim(```READ''',0),0)
	COPY(reg(1),reg(2))
	COPY(const(6),reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```LIST'''),0,2)
LABEL(39)
	CALL(prim(```READ''',0),0)
	COPY(reg(1),reg(2))
	COPY(const(7),reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```LIST'''),0,2)
LABEL(38)
	IF_NOT_EQ(stk(1),imm(-130953),40)
	CALL(lbl(42),1)
	COPY(pop,reg(0))
	JUMP(prim(```READ''',0),0)
LABEL(40)
	IF_NOT_EQ(stk(1),imm(-130989),43)
	COPY(const(8),reg(1))
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(prim(```ERROR'''),0,1)
LABEL(43)
	COPY(imm(-130979),reg(2))
	COPY(stk(1),reg(1))
	CALL(prim(```CHAR=?''',2),0)
	IF_NOT(reg(1),44)
	CALL(prim(```PEEK-CHAR''',0),0)
	CALL(lbl(2),0)
LABEL(44)
	IF_NOT(reg(1),45)
	COPY(const(9),reg(1))
	CALL(prim(```ERROR'''),0,1)
LABEL(45)
	COPY(pop,reg(1))
	CALL(lbl(6),0)
	COPY(reg(1),push)
	CALL(prim(```STRING->NUMBER''',1),0)
	IF_NOT(reg(1),46)
	DEALLOC(1)
	JUMP(pop,0)
LABEL(46)
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```STRING->SYMBOL''',1),0)
ENTRY_LABEL(16)
	ENTER(1)
LABEL(17)
	CHECK_STACK
	COPY(reg(0),push)
	COPY(reg(1),push)
	CALL(prim(```READ-CHAR''',0),0)
	IF_NOT_EQ(reg(1),imm(-131003),47)
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```MAKE-STRING''',1),0)
LABEL(47)
	IF_NOT_EQ(reg(1),imm(-130887),48)
	CALL(prim(```READ-CHAR''',0),0)
	COPY(reg(1),push)
	OPEN_CODE(prim(```+''',2),stk(2),imm(8),reg(1))
	CALL(lbl(17),0)
	COPY(pop,reg(3))
	COPY(pop,reg(2))
	COPY(pop,reg(0))
	JUMP(prim(```STRING-SET!''',3),0)
LABEL(48)
	COPY(reg(1),push)
	OPEN_CODE(prim(```+''',2),stk(2),imm(8),reg(1))
	CALL(lbl(17),0)
	COPY(pop,reg(3))
	COPY(pop,reg(2))
	COPY(pop,reg(0))
	JUMP(prim(```STRING-SET!''',3),0)
ENTRY_LABEL(18)
	ENTER(1)
LABEL(19)
	CHECK_STACK
	COPY(reg(0),push)
	COPY(reg(1),push)
	CALL(prim(```PEEK-CHAR''',0),0)
	CALL(lbl(2),0)
	IF_NOT(reg(1),49)
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```MAKE-STRING''',1),0)
LABEL(49)
	CALL(prim(```READ-CHAR''',0),0)
	CALL(prim(```CHAR-UPPERCASE''',1),0)
	COPY(reg(1),push)
	OPEN_CODE(prim(```+''',2),stk(2),imm(8),reg(1))
	CALL(lbl(19),0)
	COPY(stk(2),reg(2))
	COPY(pop,reg(3))
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(prim(```STRING-SET!''',3),0)
ENTRY_LABEL(25)
	ENTER(1)
LABEL(26)
	CHECK_STACK
	COPY(reg(0),push)
	COPY(reg(1),push)
	CALL(lbl(8),0)
	IF_NOT_EQ(reg(1),imm(-130989),50)
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```MAKE-VECTOR''',1),0)
LABEL(50)
	CALL(lbl(14),0)
	COPY(reg(1),push)
	OPEN_CODE(prim(```+''',2),stk(2),imm(8),reg(1))
	CALL(lbl(26),0)
	COPY(pop,reg(3))
	COPY(pop,reg(2))
	COPY(pop,reg(0))
	JUMP(prim(```VECTOR-SET!''',3),0)
ENTRY_LABEL(41)
	ENTER(0)
LABEL(42)
	CHECK_STACK
	COPY(reg(0),push)
	CALL(prim(```READ-CHAR''',0),0)
	COPY(reg(1),push)
	COPY(imm(80),reg(1))
	CALL(prim(```INTEGER->CHAR''',1),0)
	IF_EQ(pop,reg(1),51)
	COPY(pop,reg(0))
	JUMP(lbl(42),0)
LABEL(51)
	JUMP(pop,0)
CONST(obj40)
CONST(obj41)
CONST(obj42)
CONST(obj44)
CONST(obj46)
CONST(obj48)
CONST(obj50)
CONST(obj51)
CONST(obj52)
END

DEFINE_PRIMITIVE(`WRITE*',2)
	IF_NOT_PAIR(reg(1),7)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(const(1),reg(1))
	CALL(lbl(4),0)
	OPEN_CODE(prim(```CAR''',1),stk(2),reg(1))
	COPY(stk(1),reg(2))
	CALL(prim(```WRITE*''',2),0)
	OPEN_CODE(prim(```CDR''',1),stk(2),reg(1))
	COPY(pop,reg(2))
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(lbl(6),0)
LABEL(7)
	IF_NOT_NULL(reg(1),8)
	COPY(const(2),reg(1))
	JUMP(lbl(4),0)
LABEL(8)
	IF_NOT_EQ(reg(1),imm(-1),9)
	COPY(const(3),reg(1))
	JUMP(lbl(4),0)
LABEL(9)
	IF_NOT_EQ(reg(1),imm(-5),10)
	COPY(const(4),reg(1))
	JUMP(lbl(4),0)
LABEL(10)
	IF_NOT_SYMBOL(reg(1),11)
	COPY(reg(0),push)
	CALL(prim(```SYMBOL->STRING''',1),0)
	COPY(pop,reg(0))
	JUMP(lbl(4),0)
LABEL(11)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	CALL(prim(```NUMBER?''',1),0)
	IF_NOT(reg(1),12)
	DEALLOC(1)
	COPY(pop,reg(1))
	CALL(prim(```NUMBER->STRING''',1),0)
	COPY(pop,reg(0))
	JUMP(lbl(4),0)
LABEL(12)
	IF_NOT_STRING(stk(2),13)
	COPY(pop,reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(2),0)
LABEL(13)
	IF_NOT_VECTOR(stk(2),14)
	COPY(const(5),reg(1))
	CALL(lbl(4),0)
	COPY(stk(2),reg(1))
	CALL(prim(```VECTOR->LIST''',1),0)
	COPY(pop,reg(2))
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(prim(```WRITE*''',2),0)
LABEL(14)
	DEALLOC(1)
	IF_NOT_PROC(stk(1),15)
	COPY(pop,reg(1))
	CALL(prim(```PROCEDURE-INFO''',1),0)
	COPY(reg(1),push)
	COPY(const(6),reg(1))
	CALL(lbl(4),0)
	IF_NOT(stk(1),16)
	COPY(const(7),reg(1))
	CALL(lbl(4),0)
	COPY(imm(-1),reg(2))
	COPY(pop,reg(1))
	CALL(prim(```WRITE*''',2),0)
	JUMP(lbl(17),0)
LABEL(16)
	DEALLOC(1)
LABEL(17)
	COPY(const(8),reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(4),0)
LABEL(15)
	IF_NOT_CHAR(stk(1),18)
	COPY(const(9),reg(1))
	CALL(lbl(4),0)
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```WRITE-CHAR''',1),0)
LABEL(18)
	COPY(const(10),reg(1))
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(lbl(4),0)
ENTRY_LABEL(1)
	ENTER(2)
LABEL(2)
	CHECK_STACK
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	IF(reg(2),19)
	COPY(imm(-131003),reg(1))
	CALL(prim(```WRITE-CHAR''',1),0)
LABEL(19)
	COPY(stk(2),reg(1))
	CALL(prim(```STRING-LENGTH''',1),0)
	COPY(reg(1),push)
	COPY(imm(0),reg(3))
	COPY(stk(2),reg(2))
	COPY(stk(3),reg(1))
	CALL(lbl(21),0)
	IF(pop,22)
	COPY(imm(-131003),reg(1))
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(prim(```WRITE-CHAR''',1),0)
LABEL(22)
	DEALLOC(1)
	JUMP(pop,0)
ENTRY_LABEL(3)
	ENTER(1)
LABEL(4)
	CHECK_STACK
	COPY(imm(-5),reg(2))
	JUMP(lbl(2),0)
ENTRY_LABEL(5)
	ENTER(2)
LABEL(6)
	CHECK_STACK
	IF_NOT_PAIR(reg(1),23)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(const(11),reg(1))
	CALL(lbl(4),0)
	OPEN_CODE(prim(```CAR''',1),stk(2),reg(1))
	COPY(stk(1),reg(2))
	CALL(prim(```WRITE*''',2),0)
	OPEN_CODE(prim(```CDR''',1),stk(2),reg(1))
	COPY(pop,reg(2))
	DEALLOC(1)
	COPY(pop,reg(0))
	JUMP(lbl(6),0)
LABEL(23)
	IF_NOT_NULL(reg(1),24)
	COPY(const(12),reg(1))
	JUMP(lbl(4),0)
LABEL(24)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(const(13),reg(1))
	CALL(lbl(4),0)
	COPY(pop,reg(2))
	COPY(pop,reg(1))
	CALL(prim(```WRITE*''',2),0)
	COPY(const(14),reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(4),0)
ENTRY_LABEL(20)
	ENTER(4)
LABEL(21)
	CHECK_STACK
	IF_NOT_LT(reg(3),stk(1),25)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(reg(2),push)
	COPY(reg(3),push)
	COPY(reg(3),reg(2))
	CALL(prim(```STRING-REF''',2),0)
	COPY(reg(1),push)
	IF(stk(3),26)
	IF_NOT_EQ(reg(1),imm(-131003),27)
	COPY(imm(-130887),reg(1))
	CALL(prim(```WRITE-CHAR''',1),0)
LABEL(27)
LABEL(26)
	COPY(pop,reg(1))
	CALL(prim(```WRITE-CHAR''',1),0)
	OPEN_CODE(prim(```+''',2),pop,imm(8),reg(1))
	COPY(reg(1),reg(3))
	COPY(pop,reg(2))
	COPY(pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(21),0)
LABEL(25)
	JUMP(reg(0),1)
CONST(obj53)
CONST(obj54)
CONST(obj55)
CONST(obj56)
CONST(obj57)
CONST(obj58)
CONST(obj59)
CONST(obj60)
CONST(obj61)
CONST(obj62)
CONST(obj63)
CONST(obj64)
CONST(obj65)
CONST(obj66)
END

DEFINE_PRIMITIVE(`WRITE',1)
	COPY(imm(-1),reg(2))
	JUMP(prim(```WRITE*''',2),0)
END

DEFINE_PRIMITIVE(`DISPLAY',1)
	COPY(imm(-5),reg(2))
	JUMP(prim(```WRITE*''',2),0)
END

DEFINE_PRIMITIVE(`NEWLINE',0)
	COPY(reg(0),push)
	COPY(imm(80),reg(1))
	CALL(prim(```INTEGER->CHAR''',1),0)
	COPY(pop,reg(0))
	JUMP(prim(```WRITE-CHAR''',1),0)
END

DEFINE_PRIMITIVE(`ERROR',2,REST)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(const(1),reg(1))
	CALL(prim(```DISPLAY''',1),0)
	COPY(stk(3),reg(1))
	CALL(prim(```DISPLAY''',1),0)
	CALL(prim(```NEWLINE''',0),0)
	COPY(pop,reg(1))
	CALL(lbl(2),0)
	COPY(imm(8),reg(1))
	COPY(pop,reg(0))
	JUMP(prim(```EXIT''',1),1)
ENTRY_LABEL(1)
	ENTER(1)
LABEL(2)
	CHECK_STACK
	IF_NULL(reg(1),3)
	COPY(reg(0),push)
	COPY(reg(1),push)
	COPY(const(2),reg(1))
	CALL(prim(```DISPLAY''',1),0)
	OPEN_CODE(prim(```CAR''',1),stk(1),reg(1))
	CALL(prim(```WRITE''',1),0)
	CALL(prim(```NEWLINE''',0),0)
	OPEN_CODE(prim(```CDR''',1),pop,reg(1))
	COPY(pop,reg(0))
	JUMP(lbl(2),0)
LABEL(3)
	JUMP(reg(0),0)
CONST(obj67)
CONST(obj68)
END

|------------------------------------------------------------------------------

STRING_OBJECT(obj1)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,82,39
END

STRING_OBJECT(obj2)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,82,39
END

STRING_OBJECT(obj3)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,83,69,84,45,67,65,82,33
	.byte	39
END

STRING_OBJECT(obj4)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,83,69,84,45,67,68,82,33
	.byte	39
END

STRING_OBJECT(obj5)
	.byte	105,110,99,111,114,114,101,99,116,32
	.byte	97,114,103,117,109,101,110,116,32,116
	.byte	111,32,39,67,65,65,82,39
END

STRING_OBJECT(obj6)
	.byte	105,110,99,111,114,114,101,99,116,32
	.byte	97,114,103,117,109,101,110,116,32,116
	.byte	111,32,39,67,65,68,82,39
END

STRING_OBJECT(obj7)
	.byte	105,110,99,111,114,114,101,99,116,32
	.byte	97,114,103,117,109,101,110,116,32,116
	.byte	111,32,39,67,68,65,82,39
END

STRING_OBJECT(obj8)
	.byte	105,110,99,111,114,114,101,99,116,32
	.byte	97,114,103,117,109,101,110,116,32,116
	.byte	111,32,39,67,68,68,82,39
END

STRING_OBJECT(obj9)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,65,65,82,39
END

STRING_OBJECT(obj10)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,65,68,82,39
END

STRING_OBJECT(obj11)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,68,65,82,39
END

STRING_OBJECT(obj12)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,68,68,82,39
END

STRING_OBJECT(obj13)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,65,65,82,39
END

STRING_OBJECT(obj14)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,65,68,82,39
END

STRING_OBJECT(obj15)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,68,65,82,39
END

STRING_OBJECT(obj16)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,68,68,82,39
END

STRING_OBJECT(obj17)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,65,65,65,82,39
END

STRING_OBJECT(obj18)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,65,65,68,82,39
END

STRING_OBJECT(obj19)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,65,68,65,82,39
END

STRING_OBJECT(obj20)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,65,68,68,82,39
END

STRING_OBJECT(obj21)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,68,65,65,82,39
END

STRING_OBJECT(obj22)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,68,65,68,82,39
END

STRING_OBJECT(obj23)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,68,68,65,82,39
END

STRING_OBJECT(obj24)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,65,68,68,68,82,39
END

STRING_OBJECT(obj25)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,65,65,65,82,39
END

STRING_OBJECT(obj26)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,65,65,68,82,39
END

STRING_OBJECT(obj27)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,65,68,65,82,39
END

STRING_OBJECT(obj28)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,65,68,68,82,39
END

STRING_OBJECT(obj29)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,68,65,65,82,39
END

STRING_OBJECT(obj30)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,68,65,68,82,39
END

STRING_OBJECT(obj31)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,68,68,65,82,39
END

STRING_OBJECT(obj32)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	114,103,117,109,101,110,116,32,116,111
	.byte	32,39,67,68,68,68,68,82,39
END

STRING_OBJECT(obj33)
	.byte	105,110,100,101,120,32,97,114,103,117
	.byte	109,101,110,116,32,116,111,32,39,76
	.byte	73,83,84,45,84,65,73,76,39,32
	.byte	105,115,32,110,111,116,32,97,110,32
	.byte	105,110,116,101,103,101,114
END

STRING_OBJECT(obj34)
	.byte	105,110,100,101,120,32,97,114,103,117
	.byte	109,101,110,116,32,116,111,32,39,76
	.byte	73,83,84,45,84,65,73,76,39,32
	.byte	109,117,115,116,32,98,101,32,62,61
	.byte	32,48
END

STRING_OBJECT(obj35)
	.byte	105,110,99,111,114,114,101,99,116,32
	.byte	108,105,115,116,32,97,114,103,117,109
	.byte	101,110,116,32,116,111,32,39,76,73
	.byte	83,84,45,84,65,73,76,39
END

STRING_OBJECT(obj36)
	.byte	105,110,99,111,114,114,101,99,116,32
	.byte	108,105,115,116,32,97,114,103,117,109
	.byte	101,110,116,32,116,111,32,39,76,73
	.byte	83,84,45,82,69,70,39
END

STRING_OBJECT(obj37)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	108,105,115,116,32,99,111,117,112,108
	.byte	101,32,105,110,32,39,65,83,83,81
	.byte	39
END

STRING_OBJECT(obj38)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	108,105,115,116,32,99,111,117,112,108
	.byte	101,32,105,110,32,39,65,83,83,86
	.byte	39
END

STRING_OBJECT(obj39)
	.byte	110,111,110,45,112,97,105,114,32,97
	.byte	108,105,115,116,32,99,111,117,112,108
	.byte	101,32,105,110,32,39,65,83,83,79
	.byte	67,39
END

PAIR_OBJECT(obj40,-130953,obj69)

STRING_OBJECT(obj41)
	.byte	39,41,39,32,101,120,112,101,99,116
	.byte	101,100
END

STRING_OBJECT(obj42)
	.byte	117,110,107,110,111,119,110,32,39,35
	.byte	39,32,114,101,97,100,32,109,97,99
	.byte	114,111
END

PAIR_OBJECT(obj43,obj44,-3)

SYMBOL_OBJECT(obj44,obj70)

PAIR_OBJECT(obj45,obj46,obj43)

SYMBOL_OBJECT(obj46,obj71)

PAIR_OBJECT(obj47,obj48,obj45)

SYMBOL_OBJECT(obj48,obj72)

PAIR_OBJECT(obj49,obj50,obj47)

SYMBOL_OBJECT(obj50,obj73)

STRING_OBJECT(obj51)
	.byte	109,105,115,112,108,97,99,101,100,32
	.byte	39,41,39
END

STRING_OBJECT(obj52)
	.byte	109,105,115,112,108,97,99,101,100,32
	.byte	39,46,39
END

STRING_OBJECT(obj53)
	.byte	40
END

STRING_OBJECT(obj54)
	.byte	40,41
END

STRING_OBJECT(obj55)
	.byte	35,70
END

STRING_OBJECT(obj56)
	.byte	35,84
END

STRING_OBJECT(obj57)
	.byte	35
END

STRING_OBJECT(obj58)
	.byte	35,91,112,114,111,99,101,100,117,114
	.byte	101
END

STRING_OBJECT(obj59)
	.byte	32
END

STRING_OBJECT(obj60)
	.byte	93
END

STRING_OBJECT(obj61)
	.byte	35,92
END

STRING_OBJECT(obj62)
	.byte	35,91,117,110,107,110,111,119,110,93
END

STRING_OBJECT(obj63)
	.byte	32
END

STRING_OBJECT(obj64)
	.byte	41
END

STRING_OBJECT(obj65)
	.byte	32,46,32
END

STRING_OBJECT(obj66)
	.byte	41
END

STRING_OBJECT(obj67)
	.byte	101,114,114,111,114,58,32
END

STRING_OBJECT(obj68)
	.byte	32,32,32,32,32,32,32
END

PAIR_OBJECT(obj69,-130991,obj74)

STRING_OBJECT(obj70)
	.byte	81,85,79,84,69
END

STRING_OBJECT(obj71)
	.byte	81,85,65,83,73,81,85,79,84,69
END

STRING_OBJECT(obj72)
	.byte	85,78,81,85,79,84,69,45,83,80
	.byte	76,73,67,73,78,71
END

STRING_OBJECT(obj73)
	.byte	85,78,81,85,79,84,69
END

PAIR_OBJECT(obj74,-130989,obj75)

PAIR_OBJECT(obj75,-131001,obj76)

PAIR_OBJECT(obj76,-131003,obj77)

PAIR_OBJECT(obj77,-130993,obj78)

PAIR_OBJECT(obj78,-130879,obj79)

PAIR_OBJECT(obj79,-130983,-3)

|------------------------------------------------------------------------------

	.data2
	.align	4
	.skip	4
	.globl	_pair_area2
_pair_area2:
