(define list1 '(1 2 3 4))
(define list2 '((4) (5) (6) (7)))
(define list3 '(1 2 3 4))
(define delayed (delay (write "hello")))

(define (test x y z)
  (write x) (newline)
  (write y) (newline)
  (write z) (newline)
  (newline))

(TEST '(NOT '())
       (NOT '())
       '#T)

(TEST '(NOT 1)
       (NOT 1)
       '#f)

(TEST '(BOOLEAN? #f)
       (BOOLEAN? #f)
       '#T)

(TEST '(BOOLEAN? 1)
       (BOOLEAN? 1)
       '#f)

(TEST '(EQV? 1 1)
       (EQV? 1 1)
       '#T)

(TEST '(EQV? 3 #\3)
       (EQV? 3 #\3)
       '#f)

(TEST '(EQ? #\a #\a)
       (EQ? #\a #\a)
       '#T)

(TEST '(EQ? "a" "a")
       (EQ? "a" "a")
       '#f)

(TEST '(EQUAL? #(1 2 3) #(1 2 3))
       (EQUAL? #(1 2 3) #(1 2 3))
       '#T)

(TEST '(EQUAL? '(1 2 3) '(1 2 . 3))
       (EQUAL? '(1 2 3) '(1 2 . 3))
       '#f)

(TEST '(PAIR? '(4 5 6))
       (PAIR? '(4 5 6))
       '#T)

(TEST '(PAIR? 4)
       (PAIR? 4)
       '#f)

(TEST '(CONS 1 2)
       (CONS 1 2)
       '(1 . 2))

(TEST '(CAR LIST1)
       (CAR LIST1)
       '1)

(TEST '(CDR LIST1)
       (CDR LIST1)
       '(2 3 4))

(TEST '(SET-CAR! LIST3 4)
       (SET-CAR! LIST3 4)
       '(4 2 3 4))

(TEST '(SET-CDR! LIST3 4)
       (SET-CDR! LIST3 4)
       '(4 . 4))

(TEST 'LIST3
       LIST3
       '(4 . 4))

(TEST '(NULL? '())
       (NULL? '())
       '#T)

(TEST '(NULL? 1)
       (NULL? 1)
       '#f)

(TEST '(LIST 1 2 3)
       (LIST 1 2 3)
       '(1 2 3))

(TEST '(LENGTH LIST1)
       (LENGTH LIST1)
       '4)

(TEST '(APPEND LIST1 LIST2)
       (APPEND LIST1 LIST2)
       '(1 2 3 4 (4) (5) (6) (7)))

(TEST '(REVERSE LIST1)
       (REVERSE LIST1)
       '(4 3 2 1))

(TEST '(LIST-TAIL LIST1 2)
       (LIST-TAIL LIST1 2)
       '(3 4))

(TEST '(LIST-REF LIST1 2)
       (LIST-REF LIST1 2)
       '3)

(TEST '(LAST-PAIR LIST1)
       (LAST-PAIR LIST1)
       '(4))

(TEST '(MEMQ 2 LIST1)
       (MEMQ 2 LIST1)
       '(2 3 4))

(TEST '(MEMQ 5 LIST1)
       (MEMQ 5 LIST1)
       '#f)

(TEST '(MEMV 2 LIST1)
       (MEMV 2 LIST1)
       '(2 3 4))

(TEST '(MEMV 5 LIST1)
       (MEMV 5 LIST1)
       '#f)

(TEST '(MEMBER '(2) LIST2)
       (MEMBER '(2) LIST2)
       '#f)

(TEST '(MEMBER 5 LIST2)
       (MEMBER 5 LIST2)
       '#f)

(TEST '(ASSQ 2 LIST2)
       (ASSQ 2 LIST2)
       '#f)

(TEST '(ASSQ 5 LIST2)
       (ASSQ 5 LIST2)
       '(5))

(TEST '(ASSV 2 LIST2)
       (ASSV 2 LIST2)
       '#f)

(TEST '(ASSV 5 LIST2)
       (ASSV 5 LIST2)
       '(5))

(TEST '(ASSOC '2 LIST2)
       (ASSOC '2 LIST2)
       '#f)

(TEST '(ASSOC 5 LIST2)
       (ASSOC 5 LIST2)
       '(5))

(TEST '(SYMBOL? 'ABC)
       (SYMBOL? 'ABC)
       '#T)

(TEST '(SYMBOL? 1)
       (SYMBOL? 1)
       '#f)

(TEST '(SYMBOL->STRING 'ABC)
       (SYMBOL->STRING 'ABC)
       '"ABC")

(TEST '(STRING->SYMBOL "BONJOUR")
       (STRING->SYMBOL "BONJOUR")
       'BONJOUR)

(TEST '(EQ? (STRING->SYMBOL "BONJOUR") 'BONJOUR)
       (EQ? (STRING->SYMBOL "BONJOUR") 'BONJOUR)
       '#T)

(TEST '(NUMBER? 123)
       (NUMBER? 123)
       '#T)

(TEST '(NUMBER? #T)
       (NUMBER? #T)
       '#f)

(TEST '(REAL? #\a)
       (REAL? #\a)
       '#f)

(TEST '(INTEGER? 123)
       (INTEGER? 123)
       '#T)

(TEST '(INTEGER? 'D)
       (INTEGER? 'D)
       '#f)

(TEST '(ODD? 11)
       (ODD? 11)
       '#T)

(TEST '(ODD? 12)
       (ODD? 12)
       '#f)

(TEST '(EVEN? -12)
       (EVEN? -12)
       '#T)

(TEST '(ODD? -11)
       (ODD? -11)
       '#T)

(TEST '(= 1 1)
       (= 1 1)
       '#T)

(TEST '(= 1 2)
       (= 1 2)
       '#f)

(TEST '(< 1 2)
       (< 1 2)
       '#T)

(TEST '(< 1 1)
       (< 1 1)
       '#f)

(TEST '(> 2 1)
       (> 2 1)
       '#T)

(TEST '(> 1 1)
       (> 1 1)
       '#f)

(TEST '(<= 1 1)
       (<= 1 1)
       '#T)

(TEST '(<= 2 1)
       (<= 2 1)
       '#f)

(TEST '(>= 1 1)
       (>= 1 1)
       '#T)

(TEST '(>= 1 2)
       (>= 1 2)
       '#f)

(TEST '(MAX 3 4)
       (MAX 3 4)
       '4)

(TEST '(MIN 3 4)
       (MIN 3 4)
       '3)

(TEST '(+)
       (+)
       '0)

(TEST '(+ 12)
       (+ 12)
       '12)

(TEST '(+ 12 34)
       (+ 12 34)
       '46)

(TEST '(*)
       (*)
       '1)

(TEST '(* 12)
       (* 12)
       '12)

(TEST '(* 12 34)
       (* 12 34)
       '408)

(TEST '(- 12)
       (- 12)
       '-12)

(TEST '(- 12 34)
       (- 12 34)
       '-22)

(TEST '(/ 12)
       (/ 12)
       '0)

(TEST '(/ 100 4)
       (/ 100 4)
       '25)

(TEST '(ABS 2)
       (ABS 2)
       '2)

(TEST '(ABS -2)
       (ABS -2)
       '2)

(TEST '(QUOTIENT 50 7)
       (QUOTIENT 50 7)
       '7)

(TEST '(REMAINDER 12 5)
       (REMAINDER 12 5)
       '2)

(TEST '(REMAINDER -12 5)
       (REMAINDER -12 5)
       '-2)

(TEST '(EXPT 3 5)
       (EXPT 3 5)
       '243)

(TEST '(NUMBER->STRING 31415)
       (NUMBER->STRING 31415)
       '"31415")

(TEST '(STRING->NUMBER "-271828")
       (STRING->NUMBER "-271828")
       '-271828)

(TEST '(CHAR? #\1)
       (CHAR? #\1)
       '#T)

(TEST '(CHAR? 1)
       (CHAR? 1)
       '#f)

(TEST '(CHAR=? #\a #\a)
       (CHAR=? #\a #\a)
       '#T)

(TEST '(CHAR=? #\a #\b)
       (CHAR=? #\a #\b)
       '#f)

(TEST '(CHAR<? #\a #\b)
       (CHAR<? #\a #\b)
       '#T)

(TEST '(CHAR<? #\a #\a)
       (CHAR<? #\a #\a)
       '#f)

(TEST '(CHAR>? #\b #\a)
       (CHAR>? #\b #\a)
       '#T)

(TEST '(CHAR>? #\a #\a)
       (CHAR>? #\a #\a)
       '#f)

(TEST '(CHAR<=? #\a #\a)
       (CHAR<=? #\a #\a)
       '#T)

(TEST '(CHAR<=? #\b #\a)
       (CHAR<=? #\b #\a)
       '#f)

(TEST '(CHAR>=? #\a #\a)
       (CHAR>=? #\a #\a)
       '#T)

(TEST '(CHAR>=? #\a #\b)
       (CHAR>=? #\a #\b)
       '#f)

(TEST '(CHAR->INTEGER #\")
       (CHAR->INTEGER #\")
       '34)

(TEST '(INTEGER->CHAR 34)
       (INTEGER->CHAR 34)
       '#\")

(TEST '(CHAR-UPPERCASE #\g)
       (CHAR-UPPERCASE #\g)
       '#\G)

(TEST '(STRING? "allo")
       (STRING? "allo")
       '#T)

(TEST '(STRING? 1)
       (STRING? 1)
       '#f)

(TEST '(MAKE-STRING 4)
       (MAKE-STRING 4)
       '"    ")

(TEST '(MAKE-STRING 4 #\!)
       (MAKE-STRING 4 #\!)
       '"!!!!")

(TEST '(STRING-LENGTH "abc")
       (STRING-LENGTH "abc")
       '3)

(TEST '(STRING-REF "abc" 1)
       (STRING-REF "abc" 1)
       '#\b)

(TEST '(STRING-SET! "abc" 1 #\x)
       (STRING-SET! "abc" 1 #\x)
       '#\b)

(TEST '(STRING=? "abc" "abc")
       (STRING=? "abc" "abc")
       '#T)

(TEST '(STRING=? "abc" "qwe")
       (STRING=? "abc" "qwe")
       '#f)

(TEST '(STRING->LIST "abc")
       (STRING->LIST "abc")
       '(#\a #\b #\c))

(TEST '(LIST->STRING '(#\o #\n #\e))
       (LIST->STRING '(#\o #\n #\e))
       '"one")

(TEST '(VECTOR? #())
       (VECTOR? #())
       '#T)

(TEST '(VECTOR? 1)
       (VECTOR? 1)
       '#f)

(TEST '(MAKE-VECTOR 3)
       (MAKE-VECTOR 3)
       '#(() () ()))

(TEST '(MAKE-VECTOR 3 5)
       (MAKE-VECTOR 3 5)
       '#(5 5 5))

(TEST '(VECTOR 1 2 3)
       (VECTOR 1 2 3)
       '#(1 2 3))

(TEST '(VECTOR-LENGTH #(1 2 3))
       (VECTOR-LENGTH #(1 2 3))
       '3)

(TEST '(VECTOR-REF #(1 2 3) 1)
       (VECTOR-REF #(1 2 3) 1)
       '2)

(TEST '(VECTOR-SET! #(1 2 3) 1 5)
       (VECTOR-SET! #(1 2 3) 1 5)
       '#(1 5 3))

(TEST '(VECTOR->LIST #(1 2 3))
       (VECTOR->LIST #(1 2 3))
       '(1 2 3))

(TEST '(LIST->VECTOR LIST1)
       (LIST->VECTOR LIST1)
       '#(1 2 3 4))

(TEST '(PROCEDURE? CAR)
       (PROCEDURE? CAR)
       '#T)

(TEST '(PROCEDURE? 1)
       (PROCEDURE? 1)
       '#f)

(TEST '(PROCEDURE-INFO CAR)
       (PROCEDURE-INFO CAR)
       '"CAR")

(TEST '(APPLY + '(1 2))
       (APPLY + '(1 2))
       '3)

(TEST '(MAP - LIST1)
       (MAP - LIST1)
       '(-1 -2 -3 -4))

(TEST '(FOR-EACH WRITE LIST2)
       (FOR-EACH WRITE LIST2)
       '1)

(TEST '(FORCE DELAYED)
       (FORCE DELAYED)
       '#\o)

(TEST '(READ-CHAR)
       (READ-CHAR)
       '#\q)

(TEST '(PEEK-CHAR)
       (PEEK-CHAR)
       '#\1)

(TEST '(READ)
       (READ)
       '123)

(TEST '(EOF-OBJECT? (READ))
       (EOF-OBJECT? (READ))
       '#f)

(TEST '(IF (READ) (ERROR "oops"))
       (IF (READ) (ERROR "oops"))
       '#f)
